package BsUtils
import(
    "gopkg.in/yaml.v2"
    "io/ioutil"
	"crypto/md5"
	"encoding/hex"
	"golang.org/x/crypto/ssh"
	// "strings"
    "encoding/base64"
    "path/filepath"
    "strconv"
	"time"
    "log"
	"fmt"
)
// 连接的配置
type ClientConfig struct {
	Host       string      //ip
	Port       int64       // 端口
	Username   string      //用户名
	Password   string      //密码
	Client     *ssh.Client //ssh client
	LastResult string      //最近一次运行的结果
}
// 系统配置
type Config struct {
	Name    string `yaml:"name"`
	Version string `yaml:"version"`
    DateVersion string `yaml:"dateversion"`
	Database struct {
		Dbhostsip     string `yaml:"dbhostsip"`
		Username string `yaml:"username"`
		Password string `yaml:"password"`
        Dbname string `yaml:"dbname"`
	} `yaml:"database"`
}

// func BsCheckUserAuto(host string, port int,user string, passwd string)int{
// 	// 0 => 用户名、密码错误
// 	// 1 => 用户名、密码正确
// 	// 2 => 用户名、密码为空
// 	if passwd == "" || User == ""{
//         return 2
//     }
    
// }

// password 加密
func PasswordEncryption(password string)string {
    Salt:="fhduhgursgjioe..fonfu438hudbf"
    password=password+Salt
	data := []byte(password)
	md5New := md5.New()
	md5New.Write(data)
	// hex转字符串
	md5String := hex.EncodeToString(md5New.Sum(nil))
	return md5String
}
func BsCheckUserAuto(host string, port string,user string, passwd string,command string)(int,string){

	// 0 => 错误
	// 1 => 正确
	// 2 => 用户名、密码为空
    port_int,_:=strconv.Atoi(port)
	if passwd == "" || user == ""{
        return 2,""
    }

    sshHost := host

    sshUser := user

    sshPassword := passwd

    sshType := "password"

    sshPort := port_int

    //创建sshp登陆配置

    config := &ssh.ClientConfig{

        Timeout:         5*time.Second,//ssh 连接time out 时间一秒钟, 如果ssh验证错误 会在一秒内返回

        User:            sshUser,

        HostKeyCallback: ssh.InsecureIgnoreHostKey(), //这个可以, 但是不够安全

        //HostKeyCallback: hostKeyCallBackFunc(h.Host),

    }

    if sshType == "password" {

        config.Auth = []ssh.AuthMethod{ssh.Password(sshPassword)}

    }

    //dial 获取ssh client

	addr := fmt.Sprintf("%s:%d", sshHost, sshPort)

    sshClient, err := ssh.Dial("tcp", addr, config)

    if err != nil {
        fmt.Println("1",err)
		return 0,""
    }

    defer sshClient.Close()

    //创建ssh-session

    session, err := sshClient.NewSession()

    if err != nil {
        fmt.Println("2",err)
     return 0,""

    }

    defer session.Close()

    //执行远程命令
    var result string
    if command != ""{
        combo,err := session.CombinedOutput(command)
        if err != nil {
            fmt.Println("3",err)
            return 0,""
        }
        defer session.Close()
        result=string(combo)
    }

    return 1,result
	// if strings.Contains(result,user){
    //     fmt.Println("4",err)
    //     return 0
    // }else{
    //     return 1
    // }
}

// 判断路径
func isValidFilePath(filePath string) bool {
	allowedDir := "../data/Report"
    absAllowPath,_:=filepath.Abs(allowedDir)
	absPath, err := filepath.Abs(filePath)
	if err != nil {
		return false
	}
	if !filepath.HasPrefix(absPath, absAllowPath) {
        return false
	}
	return true
}

func ConfigYamlParse()(string,string,string,string,string,string){
    data, err := ioutil.ReadFile("config.yaml")
	if err != nil {
		log.Println(err)
	}

	// 解析 YAML 数据
	var config Config
	err = yaml.Unmarshal(data, &config)
	if err != nil {
		log.Println(err)
	}

	return config.Database.Username,config.Database.Password,config.Database.Dbhostsip,config.Database.Dbname,config.Version,config.DateVersion
}

// 编号处理获取
func generateRequestID(name string)string{
    todaystr := time.Now().Format("2006-01-02")
	end_time:= time.Now().Format("15:04:05")
	TimeData:=name+"_"+todaystr+"_"+end_time
    encodedMessage := base64.StdEncoding.EncodeToString([]byte(TimeData))
    return encodedMessage 
}