package BsUtils
import(
	"encoding/json"
	"os"
	"fmt"
	"io/ioutil"
)
// json 转换
type Json struct { 
	Time 				string  `json:"RCExploredTimeAt"`
	ExecPocNums 		int 	`json:"RCExecPocNums"`
	RCRepairedNums 		int 	`json:"RCRepairedNums"`
	RCNotFixedNums 		int		`json:"RCNotFixedNums"`
	RCNotExecPocNums 	int		`json:"RCNotExecPocNums"`
    RCFamily            string  `json:"RCFamily"`
    RCExploredVulns     []VulnInfoCommon
}
type
VulnInfoCommon struct {
    VICFormatVer           int      `json:"VICFormatVer"`
    VICId                  string   `json:"VICId"`
    VICBelong              string   `json:"VICBelong"`
    VICPackages            string   `json:"VICPackages"`
    VICBugID               string   `json:"VICBugID"`
    VICPocHazardLevel      string   `json:"VICPocHazardLevel"`
    VICSource              string   `json:"VICSource"`
    VICSiteInfo            SiteInfo
    /* */
    // other fields
}
type SiteInfo struct {
    Name                string      `json:"Name"`
    Severity            string      `json:"Severity"`
    Description         string      `json:"Description"`
    ScopeOfInfluence    string      `json:"ScopeOfInfluence"`
}
// type FastScanInfo struct {
//     VbLevel_hight       int         `json:"VbLevel_hight"`
//     VbLevel_ignore      int         `json:"VbLevel_ignore"`
//     VbLevel_low         int         `json:"VbLevel_low"`
//     VbLevel_mid         int         `json:"VbLevel_mid"`
//     VbNums              int         `json:"VbNums"`
// }

// 获取扫描结果
func GetScanResult(args string , hostname string,TimeData string)interface{}{
    loaclPath:="../data/Report/"+args+"_"+hostname+TimeData+".json"
    jsonFile, err := os.Open(loaclPath)
    checkerr(err)
    defer jsonFile.Close()
 
    jsonData, err := ioutil.ReadAll(jsonFile)
    if err!= nil {
        fmt.Println("error reading json file")
    }
    var jsonvul Json
    json.Unmarshal(jsonData,&jsonvul)
    var resultVul map[int]map[string]string
    resultVul=make(map[int]map[string]string) 
    for i:=0;i<len(jsonvul.RCExploredVulns);i++{
        resultVul[i]=make(map[string]string)
        resultVul[i]["VICId"]= jsonvul.RCExploredVulns[i].VICId
        resultVul[i]["Severity"] = jsonvul.RCExploredVulns[i].VICSiteInfo.Severity
        resultVul[i]["VICPackages"] = jsonvul.RCExploredVulns[i].VICPackages
        resultVul[i]["ScopeOfInfluence"] = jsonvul.RCExploredVulns[i].VICSiteInfo.ScopeOfInfluence
        resultVul[i]["Description"] = jsonvul.RCExploredVulns[i].VICSiteInfo.Description
        resultVul[i]["Name"] = jsonvul.RCExploredVulns[i].VICSiteInfo.Name
        resultVul[i]["BugID"] = jsonvul.RCExploredVulns[i].VICBugID
    }
    // v:=args+":"
    // fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, v, 0x1B)
    // fmt.Println("Time : ",jsonvul.Time)
    // fmt.Println("Total number of POCs executed 		: ",jsonvul.ExecPocNums)
    return map[string]interface{}{
        "Time": jsonvul.Time,
        "ExecPocNums": jsonvul.ExecPocNums,
        "RCRepairedNums": jsonvul.RCRepairedNums,
        "RCNotFixedNums": jsonvul.RCNotFixedNums,
        "RCNotExecPocNums": jsonvul.RCNotExecPocNums,
        "RCFamily": jsonvul.RCFamily,
        "vulnInfo":resultVul,
    }
}
// func GetFastScanResult(args string , hostname string,TimeData string)interface{}{
//     loaclPath:="../data/Report/"+args+"_"+hostname+TimeData+".json"
//     jsonFile, err := os.Open(loaclPath)
//     checkerr(err)
//     defer jsonFile.Close()
 
//     jsonData, err := ioutil.ReadAll(jsonFile)
//     if err!= nil {
//         fmt.Println("error reading json file")
//     }
//     var m map[string]interface{}
//     _=json.Unmarshal([]byte(jsonData),&m)
//     return m
// }