package BsUtils
import(
	"github.com/gin-gonic/gin"
    "fmt"
	// "context"
	// "encoding/json"
	"main/tools/Kybuilder"
	"path/filepath"
    "net/http"
	"sync"
	"strings"
	// "reflect"
	// "regexp"
    "main/genmai/RemoteCheck"
	"main/tools/FastScan"
    "strconv"
	"time"
)

type ResponseData struct{
	ID      string
	Message string
	VulnInfo interface{}
}
type ResponseDataErro struct{
	ID      string
	Message string
}

var Hostlist = []string {"127.0.0.1"}

// 用户登录参数
type User struct {
    Username string `json:"username" binding:"required"`
    Password string `json:"password" binding:"required"`
}

// 检测参数
type ScanArg struct{
    Host string `json:"host" binding:"required"`
    Port string `json:"port" binding:"required"`
    Username string `json:"username" binding:"required"`
    Password string `json:"password" binding:"required"`
    RootPasswd string `json:"rootpassword" binding:"required"`
	Kybuild		string `json:"kybuild" binding:"required"`
}

// 文件下载
type FileArg struct{
	FileName string `json:"fileName" binding:"required"`
}

//Token-old define
var define  = "songbangchengjin"

var waitGroup_system sync.WaitGroup
var responseDataMap_system sync.Map

var waitGroup_baseline sync.WaitGroup
var responseDataMap_baseline sync.Map


var waitGroup_fastscan sync.WaitGroup
var responseDataMap_fastscan sync.Map

var waitGroup_iso sync.WaitGroup
var responseDataMap_iso sync.Map

// 用户登录
func Login(c *gin.Context){
	var user User
	if err:=c.ShouldBind(&user); err != nil{
		fmt.Println(err)
	}
	passwordMd5:=PasswordEncryption(user.Password)
	loginBool:=LoginQuery(user.Username,passwordMd5)
	if loginBool==true{
		clientIP := c.ClientIP()
		AddLoginTimeAndIp(user.Username,clientIP)
		accessTokenOld := define+user.Username
		accessToken:=""
		accessToken, key = CookieEncryption(accessTokenOld)
		expiration := time.Now().AddDate(0,0,30)
		cookie:=http.Cookie{
			Name: "accessToken",
			Value: accessToken,
			Path: "/",
			Domain : "localhost",
			HttpOnly :true,
			Expires: expiration,
		}
		http.SetCookie(c.Writer, &cookie)
		data :=gin.H{
			"accessToken":accessToken,
		}
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "success",
			"Data": data,
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "登录失败，账号或密码错误",
		})
	}
}
// 退出处理
func Logout(c *gin.Context){
	accessToken,_:=c.Cookie("accessToken")
	logoutCookie := http.Cookie{
		Name: accessToken,
		Expires: time.Unix(0,0),
	}
	http.SetCookie(c.Writer,&logoutCookie)
}

// 获取扫描数据
func GetScanNums(c *gin.Context){
	cookie,_:=c.Cookie("accessToken")
	result, _:=CookieProving(cookie,key)
	if result == true{
		system_nums,baseline_nums,kernel_nums,fastscan_nums:=SelectScanNums()
		c.JSON(200, gin.H{
			"Code":  200,
			"Message": "suf",
			"system_nums": system_nums,
			"baseline_nums": baseline_nums,
			"kernel_nums": kernel_nums,
			"fastscan_nums": fastscan_nums,
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
	}
}

// 系统检测
func SystemCheck(c *gin.Context){
	var scanArg ScanArg
	if err:=c.ShouldBind(&scanArg); err != nil{
		fmt.Println(err)
	}
	clientIP := c.Request.Header.Get("X-Forwarded-For")
	if clientIP == "" {
		clientIP = c.Request.Header.Get("X-Real-IP")
	}
	if clientIP == "" {
		clientIP = c.ClientIP()
	}
	cookie,_:=c.Cookie("accessToken")
	result, name:=CookieProving(cookie,key)
	if result==true{
		Host:=scanArg.Host
		Port:=scanArg.Port
		PortInt, _:= strconv.Atoi(Port)
		Username:=scanArg.Username
		Password:=scanArg.Password
		var RemoteArg []string
		RemoteArg =append(RemoteArg,"system")
		RootPasswd:=scanArg.RootPasswd
		if RootPasswd != ""{
			reRootStatus,_:=BsCheckUserAuto(Host,Port,"root",RootPasswd,"")
			if reRootStatus == 0{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "Connection failed. Please check if the root passwd are correct or if the SSH service is enabled",
				})
				return
			}else if reRootStatus == 2{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "ERROR: root passwd is null",
				})
				return
			}
		}
		reStatus,_:=BsCheckUserAuto(Host,Port,Username,Password,"")
		if reStatus == 0{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
			})
			return
		}else if reStatus == 2{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "ERROR: username and passwd is null",
			})
			return
		}

			// 获取唯一值
		requestID := generateRequestID("system")

		waitGroup_system.Add(1)

		// 存储请求上下文
		responseDataMap_system.Store(requestID,nil)

		//  限制同一ip访问
		for i:=0;i<1000;i++{
			flag := 0
			for j:=0;j<len(Hostlist);j++ {
				if Hostlist[j] == Host {
					time.Sleep(1*time.Second)
					flag = 0
					break
				}else{
					flag = 1
				}
			}
			if flag == 1{
				Hostlist = append(Hostlist,Host)
				break
			}
		}

		go processRequest_system(requestID, c, Host,PortInt,Username,Password,RemoteArg,RootPasswd)

		ScanNumsAdd(name, "system", clientIP)

		c.JSON(200, gin.H{
			"Code": 200,
			"Message": "Checking....",
			"Request_id": requestID,
		})
		return
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}

func SystemResultCheck(c *gin.Context){
	cookie,_:=c.Cookie("accessToken")
	result, _:=CookieProving(cookie,key)
	if result==true {
		requestID := c.Query("id")
		waitGroup_system.Wait()
		// 从内存中获取处理结果
		result, ok := responseDataMap_system.Load(requestID)
		if !ok {
			c.String(http.StatusNotFound, "Result not found")
		}
		// 删除处理结果
		// responseDataMap.Delete(requestID)
		
		// fmt.Println(result)
		c.JSON(http.StatusOK, result)
		return
		// 返回结果给客户端
		// if len(result.VulnInfo.(map[string]interface{})) > 0{
		// 	c.JSON(http.StatusOK, gin.H{
		// 		"id": result.ID.(string),
		// 		"message":  result.Message.(string),
		// 		"vulninfo":  result.VulnInfo.(interface{}),
		// 	})
		// }else{
		// 	c.JSON(http.StatusOK, gin.H{
		// 		"id": result.ID.(string),
		// 		"message":  result.Message.(string),
		// 	})
		// 	return
		// }
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}


// 基线检测
func BaseLineCheck(c *gin.Context){
	var scanArg ScanArg
	if err:=c.ShouldBind(&scanArg); err != nil{
		fmt.Println(err)
	}
	clientIP := c.Request.Header.Get("X-Forwarded-For")
	if clientIP == "" {
		clientIP = c.Request.Header.Get("X-Real-IP")
	}
	if clientIP == "" {
		clientIP = c.ClientIP()
	}
	cookie,_:=c.Cookie("accessToken")
	result, name:=CookieProving(cookie,key)
	if result==true{
		Host:=scanArg.Host
		Port:=scanArg.Port
		PortInt, _:= strconv.Atoi(Port)
		Username:=scanArg.Username
		Password:=scanArg.Password
		var RemoteArg []string
		RemoteArg =append(RemoteArg,"baseline")
		RootPasswd:=scanArg.RootPasswd
		if RootPasswd != ""{
			reRootStatus,_:=BsCheckUserAuto(Host,Port,"root",RootPasswd,"")
			if reRootStatus == 0{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "Connection failed. Please check if the root passwd are correct or if the SSH service is enabled",
				})
				return
			}else if reRootStatus == 2{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "ERROR: root passwd is null",
				})
				return
			}
		}
		reStatus,_:=BsCheckUserAuto(Host,Port,Username,Password,"")
		if reStatus == 0{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
			})
			return
		}else if reStatus == 2{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "ERROR: username and passwd is null",
			})
			return
		}

		// 获取唯一值
		requestID := generateRequestID("baseline")

		waitGroup_baseline.Add(1)

		// 存储请求上下文
		responseDataMap_baseline.Store(requestID,nil)
		
		//  限制同一ip访问
		for i:=0;i<1000;i++{
			flag := 0
			for j:=0;j<len(Hostlist);j++ {
				if Hostlist[j] == Host {
					time.Sleep(1*time.Second)
					flag = 0
					break
				}else{
					flag = 1
				}
			}
			if flag == 1{
				Hostlist = append(Hostlist,Host)
				break
			}
		}

		go processRequest_baseline(requestID, c, Host,PortInt,Username,Password,RemoteArg,RootPasswd)

		ScanNumsAdd(name, "baseline", clientIP)

		c.JSON(200, gin.H{
			"Code": 200,
			"Message": "Checking....",
			"Request_id": requestID,
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}

func BaseLineResultCheck(c *gin.Context){

	cookie,_:=c.Cookie("accessToken")
	result, _:=CookieProving(cookie,key)
	if result==true {
		requestID := c.Query("id")
		waitGroup_baseline.Wait()
		// 从内存中获取处理结果
		result, ok := responseDataMap_baseline.Load(requestID)
		if !ok {
			c.String(http.StatusNotFound, "Result not found")
			// return
		}
	
		// 删除处理结果
		// responseDataMap.Delete(requestID)
		
		// 返回结果给客户端
		c.JSON(http.StatusOK, result)
		return
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}

// 版本匹配检测
func FastScanCheck(c *gin.Context){
	var scanArg ScanArg
	if err:=c.ShouldBind(&scanArg); err != nil{
		fmt.Println(err)
	}
	clientIP := c.Request.Header.Get("X-Forwarded-For")
	if clientIP == "" {
		clientIP = c.Request.Header.Get("X-Real-IP")
	}
	if clientIP == "" {
		clientIP = c.ClientIP()
	}
	cookie,_:=c.Cookie("accessToken")
	result, name:=CookieProving(cookie,key)
	if result==true{
		Host:=scanArg.Host
		Port:=scanArg.Port
		PortInt, _:= strconv.Atoi(Port)
		Username:=scanArg.Username
		Password:=scanArg.Password

		reStatus,_:=BsCheckUserAuto(Host,Port,Username,Password,"")
		if reStatus == 0{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
			})
			return
		}else if reStatus == 2{
			c.JSON(200, gin.H{
				"Code": 200,
				"Message":  "ERROR: username and passwd is null",
			})
			return
		}

		// 获取唯一值
		requestID := generateRequestID("FastScan")

		waitGroup_fastscan.Add(1)

		// 存储请求上下文
		responseDataMap_fastscan.Store(requestID,nil)

		go processRequest_FastScan(requestID, c,Username,Password,Host,PortInt)
		
		ScanNumsAdd(name, "fastscan", clientIP)
		c.JSON(200, gin.H{
			"Code": 200,
			"Message": "Checking....",
			"Request_id": requestID,
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}

func FastScanResultCheck(c *gin.Context){
	cookie,_:=c.Cookie("accessToken")
	result, _:=CookieProving(cookie,key)
	if result==true {
		requestID := c.Query("id")
		waitGroup_fastscan.Wait()
		// 从内存中获取处理结果
		result, ok := responseDataMap_fastscan.Load(requestID)
		if !ok {
			c.String(http.StatusNotFound, "Result not found")
			// return
		}
	
		// 删除处理结果
		// responseDataMap.Delete(requestID)
	
		// 返回结果给客户端
		c.JSON(http.StatusOK, result)
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
	}
}



// Iso扫描
func IsoScan(c *gin.Context){
	var scanArg ScanArg
	if err:=c.ShouldBind(&scanArg); err != nil{
		fmt.Println(err)
	}
	clientIP := c.Request.Header.Get("X-Forwarded-For")
	if clientIP == "" {
		clientIP = c.Request.Header.Get("X-Real-IP")
	}
	if clientIP == "" {
		clientIP = c.ClientIP()
	}
	cookie,_:=c.Cookie("accessToken")
	result, name:=CookieProving(cookie,key)
	if result==true{
		var Kybuild string
		var PROJECT_CODENAME string
		var framwork string
		Host:=scanArg.Host
		Port:=scanArg.Port
		// PortInt, _:= strconv.Atoi(Port)
		Username:=scanArg.Username
		Password:=scanArg.Password
		Kybuild=scanArg.Kybuild
		if Kybuild == "auto" || Kybuild == ""{
			reStatus,outStr:=BsCheckUserAuto(Host,Port,Username,Password,"cat /etc/kylin-build |awk 'NR==3{print $2}'")
			_,PROJECT_CODENAME=BsCheckUserAuto(Host,Port,Username,Password,"cat /etc/os-release | awk 'NR==14{print $1}'")
			_,framwork=BsCheckUserAuto(Host,Port,Username,Password,"uname -m")
			if reStatus == 0{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
				})
				return
			}else if reStatus == 2{
				c.JSON(200, gin.H{
					"Code": 200,
					"Message":  "ERROR: username and passwd is null",
				})
				return
			}
			outStr=strings.TrimSpace(outStr)
			Kybuild = outStr
			PROJECT_CODENAME=strings.TrimSpace(PROJECT_CODENAME)
			framwork=strings.TrimSpace(framwork)
		}


		// 获取唯一值
		requestID := generateRequestID("IsoScan")

		waitGroup_iso.Add(1)

		// 存储请求上下文
		responseDataMap_iso.Store(requestID,nil)

		go processRequest_Iso(requestID, c,Kybuild,PROJECT_CODENAME,framwork)
		
		ScanNumsAdd(name, "fastscan", clientIP)
		c.JSON(200, gin.H{
			"Code": 200,
			"Message": "Checking....",
			"Request_id": requestID,
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
		return
	}
}

func IsoScanResultCheck(c *gin.Context){
	cookie,_:=c.Cookie("accessToken")
	result, _:=CookieProving(cookie,key)
	if result==true {
		requestID := c.Query("id")
		waitGroup_iso.Wait()
		// 从内存中获取处理结果
		result, ok := responseDataMap_iso.Load(requestID)
		if !ok {
			c.String(http.StatusNotFound, "Result not found")
			// return
		}
	
		// 删除处理结果
		// responseDataMap.Delete(requestID)
	
		// 返回结果给客户端
		c.JSON(http.StatusOK, result)
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
	}
}
// func Test(c *gin.Context){
// 	requestID := c.Query("id")
// 	fmt.Println(requestID)
// 	result:=123
// 	c.JSON(http.StatusOK, result)
// }

// 用户添加
func AddUser(c *gin.Context){
	var user User
	if err:=c.ShouldBind(&user); err != nil{
		fmt.Println(err)
	}
	cookie,_:=c.Cookie("accessToken")
	result,_:=CookieProving(cookie,key)
	if result==true{
		Username:=user.Username
		Password:=user.Password
		re:=AddUserDB(Username,Password)
		if re==true{
			c.JSON(200, gin.H{
				"Code"   : 200,
				"Message": "Successfully added user",
			})
		}else{
			c.JSON(200, gin.H{
				"Code"   :  200,
				"Message": "Failed to add user,User exists",
			})
		}
	}else{
		c.JSON(200, gin.H{
			"Code": 500,
			"Message":  "Identity authentication failed",
		})
	}
}

func GetVersion(c *gin.Context){
	_,_,_,_,version,dateversion:=ConfigYamlParse()
	c.JSON(200, gin.H{
		"Code": 200,
		"Version":  version,
		"DateVersion":  dateversion,
	})
}

// 文件获取
func FileDownload(c *gin.Context){
	var fileArg FileArg
	if err:=c.ShouldBind(&fileArg); err != nil{
		fmt.Println(err)
	}
	cookie,_:=c.Cookie("accessToken")
	result,_:=CookieProving(cookie,key)
	if result == true{
		filename:=fileArg.FileName
		filePath:="../data/Report/"+filename
		fmt.Println(filePath)
		if !isValidFilePath(filePath) {
			c.JSON(200, gin.H{
				"Code": 500,
				"Message":  "Invalid file path",
			})
			// return
		}
		absPath, err := filepath.Abs(filePath)
		if err != nil {
			c.String(http.StatusInternalServerError, "Internal server error")
			// return
		}

		c.FileAttachment(absPath, filepath.Base(absPath))
	}
}

// 更新data目录文件
func UpdateData(c *gin.Context){
	Username:=c.PostForm("username")
	Password:=c.PostForm("password")
	Host:=c.PostForm("host")
	Port:=c.PostForm("port")
	PortInt, _:= strconv.Atoi(Port)
	reStatus,_:=BsCheckUserAuto(Host,Port,Username,Password,"")
	if reStatus == 0{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
		})
		return
	}else if reStatus == 2{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "ERROR: username and passwd is null",
		})
		return
	}
	if RemoteCheck.RemoteUpdateData(Host,PortInt,Username,Password){
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "SUCCESS: data update success",
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "ERROR: data update failed",
		})
	}
}

func UpdateSrc(c *gin.Context){
	Username:=c.PostForm("username")
	Password:=c.PostForm("password")
	Host:=c.PostForm("host")
	Port:=c.PostForm("port")
	PortInt, _:= strconv.Atoi(Port)
	reStatus,_:=BsCheckUserAuto(Host,Port,Username,Password,"")
	if reStatus == 0{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "Connection failed. Please check if the username and password are correct or if the SSH service is enabled",
		})
		return
	}else if reStatus == 2{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "ERROR: username and passwd is null",
		})
		return
	}
	if RemoteCheck.RemoteUpdateSrc(Host,PortInt,Username,Password){
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "SUCCESS: src update success",
		})
	}else{
		c.JSON(200, gin.H{
			"Code": 200,
			"Message":  "ERROR: src update failed",
		})
	}
}

func processRequest_FastScan(requestID string, c *gin.Context,Username string,Password string,Host string,PortInt int) {
	// 模拟长时间的处理过程
	// 这里可以执行复杂的业务逻辑或耗时的操作
	// ...
	defer waitGroup_fastscan.Done()
	// var re map[string]interface{}
	re,_ := FastScan.GetdpkgInfo(Username,Password,Host,PortInt)
	// 在处理完成后更新结果

	responseData := ResponseData{
		ID:      requestID,
		Message: "Request processed successfully",
		VulnInfo: re,
		
	}
	responseDataMap_fastscan.Store(requestID, responseData)
}

func processRequest_Iso(requestID string, c *gin.Context,kybuild string,PROJECT_CODENAME string ,framwork string) {
	// 模拟长时间的处理过程
	// 这里可以执行复杂的业务逻辑或耗时的操作
	// ...
	defer waitGroup_iso.Done()
	// var re map[string]interface{}
	re:=Kybuilder.GenmaiIsoScan(kybuild)

	var sep string = " "
	dpkgInfo := strings.Split(re, sep)
	_re,_:=FastScan.MakeFastScan(dpkgInfo , PROJECT_CODENAME ,framwork) 
	// 在处理完成后更新结果

	responseData := ResponseData{
		ID:      requestID,
		Message: "Request processed successfully",
		VulnInfo: _re,
		
	}
	responseDataMap_iso.Store(requestID, responseData)
}

func processRequest_system(requestID string, c *gin.Context,Host string,PortInt int,Username string,Password string,RemoteArg []string,RootPasswd string) {
	// 模拟长时间的处理过程
	// 这里可以执行复杂的业务逻辑或耗时的操作
	// ...


	defer waitGroup_system.Done()
	// var re map[string]interface{}
	re,TimeData:=RemoteCheck.RemoteScan(Host,PortInt,Username,Password,RemoteArg,RootPasswd)
	
	// fmt.Println("<<<<<<<<<",Hostlist)
	// if len(TimeData) > 0 {
		hostresult := Hostlist[:0]
		for _,value := range Hostlist {
			if value != Host {
				hostresult =append(hostresult,value)
			}
		}
		Hostlist = hostresult
	// }

	// 在处理完成后更新结果
	var responseData ResponseData
	var responseDataErro ResponseDataErro
	if re == 1 {
		info:=GetScanResult(RemoteArg[0],Host,TimeData)
		responseData = ResponseData{
			ID:      requestID,
			Message: "Request processed successfully",
			VulnInfo: info,	
		}
		responseDataMap_system.Store(requestID, responseData)
	}else if re == 1000 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Connection error, please check the account password",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}else if re == 1001 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "This architecture does not support detection",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}else if re == 1002 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "JSON file acquisition error",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}else if re == 1003 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "PDF file acquisition error",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}else if re == 101 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Update failed, please contact the administrator",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}else if re == 100 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Successfully updated, please execute again",		
		}
		responseDataMap_system.Store(requestID, responseDataErro)
	}
}
func processRequest_baseline(requestID string, c *gin.Context,Host string,PortInt int,Username string,Password string,RemoteArg []string,RootPasswd string) {
	// 模拟长时间的处理过程
	// 这里可以执行复杂的业务逻辑或耗时的操作
	// ...


	defer waitGroup_baseline.Done()
	// var re map[string]interface{}
	re,TimeData:=RemoteCheck.RemoteScan(Host,PortInt,Username,Password,RemoteArg,RootPasswd)
	
	// fmt.Println("<<<<<<<<<",Hostlist)
	// if len(TimeData) > 0 {
		hostresult := Hostlist[:0]
		for _,value := range Hostlist {
			if value != Host {
				hostresult =append(hostresult,value)
			}
		}
		Hostlist = hostresult
	// }

	// 在处理完成后更新结果
	var responseData ResponseData
	var responseDataErro ResponseDataErro
	if re == 1 {
		info:=GetScanResult(RemoteArg[0],Host,TimeData)
		responseData = ResponseData{
			ID:      requestID,
			Message: "Request processed successfully",
			VulnInfo: info,	
		}
		responseDataMap_baseline.Store(requestID, responseData)
	}else if re == 1000 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Connection error, please check the account password",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}else if re == 1001 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "This architecture does not support detection",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}else if re == 1002 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "JSON file acquisition error",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}else if re == 1003 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "PDF file acquisition error",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}else if re == 101 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Update failed, please contact the administrator",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}else if re == 100 {
		responseDataErro = ResponseDataErro{
			ID:      requestID,
			Message: "Successfully updated, please execute again",		
		}
		responseDataMap_baseline.Store(requestID, responseDataErro)
	}
}
