package BsUtils
import(
	"github.com/gin-gonic/gin"
)

func Route(r *gin.Engine){
	// 获取扫描信息
	r.GET("/mock-server/api/getScanNums", GetScanNums)
	
	// 获取版本信息
	r.GET("/mock-server/api/getVersion", GetVersion)
	
	// 更新data目录下文件
	r.POST("/mock-server/api/updateData", UpdateData)

	// 更新src目录下文件
	r.POST("/mock-server/api/updateSrc", UpdateSrc)

	// 文件获取
	r.POST("/mock-server/api/fileDownload", FileDownload)

	// 登录退出
	r.POST("/mock-server/api/login", Login)
	r.POST("/mock-server/api/logout", Logout)

	// 系统检测 - 原理检测
	r.POST("/mock-server/api/system", SystemCheck)
	r.GET("/mock-server/api/SystemResult", SystemResultCheck)

	// 基线配置项检测
	r.POST("/mock-server/api/baseline", BaseLineCheck)
	r.GET("/mock-server/api/baselineResult", BaseLineResultCheck)

	// 系统检测 - 版本匹配检测
	r.POST("/mock-server/api/FastScan", FastScanCheck)
	r.GET("/mock-server/api/FastScanResult", FastScanResultCheck)
	// r.GET("/mock-server/api/FastScanResult1", Test)

	// Iso扫描检测
	r.POST("/mock-server/api/Iso", IsoScan)
	r.GET("/mock-server/api/IsoResult", IsoScanResultCheck)

	// 用户管理
	r.POST("/mock-server/api/addUser", AddUser)
}