////////////////////////////////////////////////////////////////
//
//       Filename:  Doctor.go
//
//        Version:  1.0
//        Created:  2022年11月08日 16时07分33秒
//       Revision:  none
//       Compiler:  go
//
//         Author:  alpha
//   Organization:  alpha
//       Contacts:  chenxinquan@kylinos.com
//
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Description:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Log:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Todo:
//
////////////////////////////////////////////////////////////////

package genmai

import (
    "fmt"
    "os"
    "sync"
    "os/exec"
    "time"
    // "bytes"
    // "strings"
    // "log"
    // "strings"
    "strconv"
    "github.com/mitchellh/mapstructure"
    "github.com/google/uuid"
    sandbox "main/genmai/Sandbox"
    "main/tools/FastScan"
)

const (
    EXP_TYPE_DBus       = "dbus"
    EXP_TYPE_KERNEL     = "kernel"
    EXP_TYPE_SYSTEM     = "system"
    EXP_TYPE_WEB        = "web"
    EXP_TYPE_BASELINE   = "baseline"
)

type
doctor struct {
    ExplorersDBus       map[string]ExplorerDBus
    ExplorersKernel     map[string]ExplorerKernel
    ExplorersSystem     map[string]ExplorerSystem
    ExplorersWeb        map[string]ExplorerWeb
    ExplorersBaseLine   map[string]ExplorerBaseLine
    Passwd              string
    Passwd_nor          string
    Username            string
    Port                string
    Host                string
    Remote              string
    //
    TargetIps           []string
    TargetPorts         []string
    //
    StartTime           string
}


type
ExplorerItem struct {
    ConfigFile          string

}
type
ExplorersListConfig struct {
    ConfigFilePrefix    string
    RootPasswd          string
    Type                string
    TargetIps           []string
    TargetPorts         []string
    ExplorerItems       []ExplorerItem
}

///////////////////////////////
// Singleton
//type Singleton interface {
//}

var (
    instance    *doctor
    once        sync.Once
    BaseLineExecPoc             int = 0
    BaseLineRepairedNums        int = 0
    BaseLineNotFixedNums        int = 0
    BaseLineNotExecPocNums      int = 0
    SystemExecPoc               int = 0
    SystemRepairedNums          int = 0
    SystemNotFixedNums          int = 0
    SystemNotExecPocNums        int = 0
    KernelExecPoc               int = 0
    KernelRepairedNums          int = 0
    KernelNotFixedNums          int = 0
    KernelNotExecPocNums        int = 0
    Risk_system_h_nums          int = 0
    Risk_system_m_nums          int = 0
    Risk_system_l_nums          int = 0
    Risk_kernel_h_nums          int = 0
    Risk_kernel_m_nums          int = 0
    Risk_kernel_l_nums          int = 0
    WebExecPoc                  int = 0
    WebRepairedNums             int = 0
    WebNotFixedNums             int = 0
    WebNotExecPocNums           int = 0
    SystemStatus                int = 0
    SystemNeed                  []string
    SystemRootNeed              []string

    BaselineStatus                int = 0
    BaselineNeed                  []string
    BaselineRootNeed              []string
)

func
DoctorIns() (*doctor) {
    once.Do( func() {
        instance = &doctor{}
        // go is fuck,
        // it will cause panic: assignment to entry in nil map
        // without this
        instance.ExplorersKernel =   make(map[string]ExplorerKernel)
        instance.ExplorersBaseLine = make(map[string]ExplorerBaseLine)
    }) // once.Do ...

    return instance
}

///////////////////////////////
// doctor functions
func
(dtr *doctor)Reset() {
    // 清空所有map元素
    dtr.ExplorersDBus   = make(map[string]ExplorerDBus)
    dtr.ExplorersKernel = make(map[string]ExplorerKernel)
    dtr.ExplorersSystem = make(map[string]ExplorerSystem)
    dtr.ExplorersWeb    = make(map[string]ExplorerWeb)
    dtr.ExplorersBaseLine = make(map[string]ExplorerBaseLine)
}

func
(dtr *doctor)Genmai() (rps []ReportBase) {

    // dtr.GenmaiBaseline()
    // dtr.GenmaiKernel()
    return rps

    // var wg sync.WaitGroup
    // wg.Add(1) // task 数必须正确

    // lock_rps := sync.Mutex{}

    // // task 1
    // go func() {
    //     defer wg.Done()

    //     rp := dtr.GenmaiKernel()

    //     lock_rps.Lock()
    //     defer lock_rps.Unlock()
    //     rps = append(rps, rp)
    // } ()

    // // task 2
    // go func () {
    //     defer wg.Done()

    //     rp := dtr.GenmaiSystem()

    //     lock_rps.Lock()
    //     defer lock_rps.Unlock()
    //     rps = append(rps, rp)

    // } ()

    // wg.Wait()

    // return rps
}


func
(dtr *doctor)GenmaiBaseline() (rp *ReportBaseLine) {


    rp = GetTemplateReportBaseLine()
    var expip4addr []string
    expip4addr = append(expip4addr, "0.0.0.0")
    var expip6addr []string
    expip6addr = append(expip6addr, "0.0.0.0")
    _,arch:=GetCurrentFw()
    /* */
    rp.RCServerUUID        = uuid.New().String()
    rp.RCServerName, _     = os.Hostname()
    rp.RCFamily            = arch
    rp.RCRelease           = "RCRelease"
    rp.RCContainer         = "RCContainer"
    /* */
    rp.RCExploredType      = "BaseLine"
    rp.RCExploredTimeAt    = time.Now()
    rp.RCExploredMode      = "RCExploredMode"
    rp.RCExploredVersion   = "RCExploredVersion"
    rp.RCExploredRevision  = "RCExploredRevision"
    rp.RCExploredBy        = "RCExploredBy"
    rp.RCExploredVia       = "RCExploredVia"
    rp.RCExploredIPv4Addrs = expip4addr
    rp.RCExploredIPv6Addrs = expip6addr
    /* */
    rp.RCReportedAt        = time.Now()
    rp.RCReportedVersion   = "RCReportedVersion"
    rp.RCReportedBy        = "RCReportedBy"
    /* */
    rp.RCErrors            = "RCErrors"
    rp.RCWarnings          = "RCWarnings"

    rp.RCReunningKernelInfo = ReportKernelInfo {
                            "0.0",
                            "0.0",
                            false,
                        }
    rp.RCPackages          = "RCPackages"
    rp.RCSrcPackages       = "RCSrcPackages"
    rp.RCOptional          = "RCOptional"

    var wg sync.WaitGroup
    wg.Add(len(dtr.ExplorersBaseLine))
    /* */
    lock_expvuls := sync.Mutex{}
    var expvuls []VulnInfoCommon
    /* */
    for _, v := range dtr.ExplorersBaseLine {
        BaseLineExecPoc =BaseLineExecPoc+1
        go func(v_ ExplorerBaseLine) {
            defer wg.Done()

            rcvul:=dtr.BaseLineControl(v_)
            if rcvul==true{
                BaseLineNotExecPocNums=BaseLineNotExecPocNums+1
            }
            expvul, rc := v_.Explore()
            if nil != rc {
            }
            // TODO: is append expvul to expvuls according to rc
            lock_expvuls.Lock()
            defer lock_expvuls.Unlock()
            if len(expvul.VICId) !=0{
                BaseLineNotFixedNums=BaseLineNotFixedNums+1
                expvuls = append(expvuls, expvul)
            }else{
                BaseLineRepairedNums =BaseLineRepairedNums+1
                infoExist:="Baseline info: "+expvul.VICId+" non-exists"
                        fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 34, infoExist, 0x1B)
            }
        } (v)

    } // for _, v ...
    /* */
    wg.Wait()
    /* */
    BaseLineRepairedNums=BaseLineRepairedNums-BaseLineNotExecPocNums
    fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33,"=================Baseline Scan Results====================\n" , 0x1B)
    fmt.Println("time",dtr.StartTime)
    fmt.Println("BaseLineExecPoc: ",BaseLineExecPoc)
    fmt.Println("BaseLineRepairedNums: ",BaseLineRepairedNums)
    fmt.Println("BaseLineNotFixedNums:",BaseLineNotFixedNums)
    fmt.Println("BaseLineNotExecPocNums",BaseLineNotExecPocNums)
    // TODO: should be type: ConfigCommon..
    rp.RCExploredVulns      = expvuls
    /* */
    rp.RCReportedAt         = time.Now()
    rp.RCElapsedTime        = time.Since(rp.RCExploredTimeAt)
    /*Exec result */
    rp.RCExecPocNums       = BaseLineExecPoc
    rp.RCRepairedNums      = BaseLineRepairedNums
    rp.RCNotFixedNums      = BaseLineNotFixedNums
    rp.RCNotExecPocNums    = BaseLineNotExecPocNums

    return rp
}
func
(dtr *doctor)GenmaiKernel() (rp *ReportKernel) {
    rp = GetTemplateReportKernel()

    var expip4addr []string
    expip4addr = append(expip4addr, "0.0.0.0")
    var expip6addr []string
    expip6addr = append(expip6addr, "0.0.0.0")
    _,arch:=GetCurrentFw()
    /* */
    rp.RCServerUUID        = uuid.New().String()
    rp.RCServerName, _     = os.Hostname()
    rp.RCFamily            = arch
    rp.RCRelease           = "RCRelease"
    rp.RCContainer         = "RCContainer"
    /* */
    rp.RCExploredType      = "Kernel"
    rp.RCExploredTimeAt    = time.Now()
    rp.RCExploredMode      = "RCExploredMode"
    rp.RCExploredVersion   = "RCExploredVersion"
    rp.RCExploredRevision  = "RCExploredRevision"
    rp.RCExploredBy        = "RCExploredBy"
    rp.RCExploredVia       = "RCExploredVia"
    rp.RCExploredIPv4Addrs = expip4addr
    rp.RCExploredIPv6Addrs = expip6addr
    /* */
    rp.RCReportedAt        = time.Now()
    rp.RCReportedVersion   = "RCReportedVersion"
    rp.RCReportedBy        = "RCReportedBy"
    /* */
    rp.RCErrors            = "RCErrors"
    rp.RCWarnings          = "RCWarnings"

    rp.RCReunningKernelInfo = ReportKernelInfo {
                            "0.0",
                            "0.0",
                            false,
                        }
    rp.RCPackages          = "RCPackages"
    rp.RCSrcPackages       = "RCSrcPackages"
    rp.RCOptional          = "RCOptional"

    var wg sync.WaitGroup
    wg.Add(len(dtr.ExplorersKernel))
    /* */
    lock_expvuls := sync.Mutex{}
    var expvuls []VulnInfoCommon
    /* */
    for _, v := range dtr.ExplorersKernel {
        KernelExecPoc =KernelExecPoc+1
        go func(v_ ExplorerKernel) {
            defer wg.Done()

            result:=dtr.KernelControl(v_)
            if result==true{
                KernelNotExecPocNums=KernelNotExecPocNums+1
                return
            }

            expvul, rc := v_.Explore()

            // TODO: is append expvul to expvuls according to rc
            if nil != rc {
            }

            lock_expvuls.Lock()
            defer lock_expvuls.Unlock()
            if len(expvul.VICId) !=0{
                KernelNotFixedNums = KernelNotFixedNums + 1
                expvuls = append(expvuls, expvul)
                config, _ := v_.GetExplorerConfigKernel()

                if config.SiteInfo.Severity == "critical" || config.SiteInfo.Severity == "high" || config.SiteInfo.Severity == "Critical" || config.SiteInfo.Severity == "High"{
                    Risk_kernel_h_nums = Risk_kernel_h_nums + 1
                }else if config.SiteInfo.Severity == "medium" || config.SiteInfo.Severity == "Medium"{
                    Risk_kernel_m_nums = Risk_kernel_m_nums + 1
                }else if config.SiteInfo.Severity == "low" || config.SiteInfo.Severity == "Low" {
                    Risk_kernel_l_nums = Risk_kernel_l_nums + 1
                }else{
                    fmt.Println(config.Id)
                }
            }else{
                KernelRepairedNums = KernelRepairedNums + 1
            }
        } (v)

    } // for _, v ...
    /* */
    wg.Wait()
    fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33,"==================Kernel Scan Results=====================\n" , 0x1B)
    fmt.Println("KernelExecPoc: ",KernelExecPoc)
    fmt.Println("KernelRepairedNums: ",KernelRepairedNums)
    fmt.Println("KernelNotFixedNums:",KernelNotFixedNums)
    fmt.Println("KernelNotExecPocNums",KernelNotExecPocNums)
    // TODO: should be type: ConfigCommon..
    rp.RCExploredVulns      = expvuls
    /* */
    rp.RCReportedAt         = time.Now()
    rp.RCElapsedTime        = time.Since(rp.RCExploredTimeAt)
    /*Exec result */
    rp.RCExecPocNums       = KernelExecPoc
    rp.RCRepairedNums      = KernelRepairedNums
    rp.RCNotFixedNums      = KernelNotFixedNums
    rp.RCNotExecPocNums    = KernelNotExecPocNums

    return rp
}
func
(dtr *doctor)GenmaiSystem() (rp *ReportSystem) {
    rp = GetTemplateReportSystem()

    var expip4addr []string
    expip4addr = append(expip4addr, "0.0.0.0")
    var expip6addr []string
    expip6addr = append(expip6addr, "0.0.0.0")
    _,arch:=GetCurrentFw()
    /* */
    rp.RCServerUUID        = uuid.New().String()
    rp.RCServerName, _     = os.Hostname()
    rp.RCFamily            = arch
    rp.RCRelease           = "RCRelease"
    rp.RCContainer         = "RCContainer"
    /* */
    rp.RCExploredType      = "System"
    rp.RCExploredTimeAt    = time.Now()
    rp.RCExploredMode      = "RCExploredMode"
    rp.RCExploredVersion   = "RCExploredVersion"
    rp.RCExploredRevision  = "RCExploredRevision"
    rp.RCExploredBy        = "RCExploredBy"
    rp.RCExploredVia       = "RCExploredVia"
    rp.RCExploredIPv4Addrs = expip4addr
    rp.RCExploredIPv6Addrs = expip6addr
    /* */
    rp.RCReportedAt        = time.Now()
    rp.RCReportedVersion   = "RCReportedVersion"
    rp.RCReportedBy        = "RCReportedBy"
    /* */
    rp.RCErrors            = "RCErrors"
    rp.RCWarnings          = "RCWarnings"

    rp.RCReunningKernelInfo = ReportKernelInfo {
                            "0.0",
                            "0.0",
                            false,
                        }
    rp.RCPackages          = "RCPackages"
    rp.RCSrcPackages       = "RCSrcPackages"
    rp.RCOptional          = "RCOptional"

    var wg sync.WaitGroup
    wg.Add(len(dtr.ExplorersSystem))
    /* */
    lock_expvuls  := sync.Mutex{}
    var expvuls []VulnInfoCommon
    for _, v := range dtr.ExplorersSystem {
        SystemExecPoc = SystemExecPoc + 1
        go func(v_ ExplorerSystem) {
            defer wg.Done()

            re:=dtr.SystemControl(v_)
            if re==false{
                SystemNotExecPocNums=SystemNotExecPocNums+1
                return
            }
            // return
            expvul, rc := v_.Explore()
            // TODO: is append expvul to expvuls according to rc
            if nil != rc {
            }

            lock_expvuls.Lock()
            defer lock_expvuls.Unlock()

            if len(expvul.VICId) !=0{
                SystemNotFixedNums = SystemNotFixedNums + 1
                expvuls = append(expvuls, expvul)
                // fmt.Println(v_.GetExplorerConfigSystem().SiteInfo)
                config, _ := v_.GetExplorerConfigSystem()
                if config.SiteInfo.Severity == "critical" || config.SiteInfo.Severity == "high" || config.SiteInfo.Severity == "Critical" || config.SiteInfo.Severity == "High" {
                    Risk_system_h_nums = Risk_system_h_nums + 1
                }else if config.SiteInfo.Severity == "medium" ||  config.SiteInfo.Severity == "Medium"{
                    Risk_system_m_nums = Risk_system_m_nums + 1
                }else if config.SiteInfo.Severity == "low" || config.SiteInfo.Severity == "Low"{
                    Risk_system_l_nums = Risk_system_l_nums + 1
                }else {
                    fmt.Println(config.Id)
                }


                // rc = rc1
                // if (nil != rc) {
                //     A_DEBUG_ERROR("exploreWithPath()-> "+
                //                   "GetExplorerConfigSystem() error ! rc = ",
                //                   rc                                        )
                //     /* */
                //     return rc
                // } // if (nil != ...
                // fmt.Println(config.SiteInfo)
            }else{
                SystemRepairedNums = SystemRepairedNums + 1
            }
        } (v)

    } // for _, v ...
    /* */
    wg.Wait()

    // 展示需要用户密码以及需要root密码的poc
    if SystemStatus == 1{
        fmt.Println("\n")
        for i:=0;i<len(SystemNeed);i++{
            infoWarn:="System warning: "+SystemNeed[i]+" username,password not configured, unable to perform full detection "
            fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
        }
        for i:=0;i<len(SystemRootNeed);i++{
            infoWarn:="System warning: "+SystemRootNeed[i]+" High power password is none "+",Can't use for high privilege system scan"
            fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
        }
        fmt.Println("\n")
    }
    fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33,"\n✎✎✎------------------------------漏洞POC验证检测结果-----------------------------------\n" , 0x1B)
    fmt.Println("完成检测时间: ",dtr.StartTime)
    // fmt.Println("SystemExecPoc: ",SystemExecPoc)
    // fmt.Println("SystemRepairedNums: ",SystemRepairedNums)
    // fmt.Println("SystemNotFixedNums:",SystemNotFixedNums)
    // fmt.Println("SystemNotExecPocNums",SystemNotExecPocNums)
    fmt.Println("已执行POC数量: ",SystemExecPoc)
    fmt.Println("已修复漏洞数量: ",SystemRepairedNums)
    fmt.Println("未修复漏洞数量: ",SystemNotFixedNums)
    fmt.Println("未执行POC数量:",SystemNotExecPocNums)
    // TODO: should be type: ConfigCommon..
    rp.RCExploredVulns      = expvuls
    /* */
    rp.RCReportedAt         = time.Now()
    rp.RCElapsedTime        = time.Since(rp.RCExploredTimeAt)
    /*Exec result */
    rp.RCExecPocNums       = SystemExecPoc
    rp.RCRepairedNums      = SystemRepairedNums
    rp.RCNotFixedNums      = SystemNotFixedNums
    rp.RCNotExecPocNums    = SystemNotExecPocNums
    rp.RCRisk_system_h_nums      = Risk_system_h_nums
    rp.RCRisk_system_m_nums      = Risk_system_m_nums
    rp.RCRisk_system_l_nums      = Risk_system_l_nums

    return rp
}

func
(dtr *doctor)GenmaiWeb() (rp *ReportWeb) {
    rp = GetTemplateReportWeb()

    expip4addr := dtr.TargetIps

    var expip6addr []string
    expip6addr = append(expip6addr, "0.0.0.0")
    /* */
    rp.RCServerUUID        = uuid.New().String()
    rp.RCServerName, _     = os.Hostname()
    rp.RCFamily            = "RCFamily"
    rp.RCRelease           = "RCRelease"
    rp.RCContainer         = "RCContainer"
    /* */
    rp.RCExploredType      = "Web"
    rp.RCExploredTimeAt    = time.Now()
    rp.RCExploredMode      = "RCExploredMode"
    rp.RCExploredVersion   = "RCExploredVersion"
    rp.RCExploredRevision  = "RCExploredRevision"
    rp.RCExploredBy        = "RCExploredBy"
    rp.RCExploredVia       = "RCExploredVia"
    rp.RCExploredIPv4Addrs = expip4addr
    rp.RCExploredIPv6Addrs = expip6addr
    /* */
    rp.RCReportedAt        = time.Now()
    rp.RCReportedVersion   = "RCReportedVersion"
    rp.RCReportedBy        = "RCReportedBy"
    /* */
    rp.RCErrors            = "RCErrors"
    rp.RCWarnings          = "RCWarnings"

    rp.RCReunningKernelInfo = ReportKernelInfo {
                            "0.0",
                            "0.0",
                            false,
                        }
    rp.RCPackages          = "RCPackages"
    rp.RCSrcPackages       = "RCSrcPackages"
    rp.RCOptional          = "RCOptional"

    var wg sync.WaitGroup
    wg.Add(len(dtr.ExplorersWeb))
    /* */
    lock_expvuls  := sync.Mutex{}
    var expvuls []VulnInfoCommon
    for _, v := range dtr.ExplorersWeb {
        WebExecPoc = WebExecPoc + 1
        go func(v_ ExplorerWeb) {
            defer wg.Done()

            expvul, rc := v_.Explore()
            // TODO: is append expvul to expvuls according to rc
            if nil != rc {
            }

            lock_expvuls.Lock()
            defer lock_expvuls.Unlock()

            if len(expvul.VICId) !=0{
                WebNotFixedNums = WebNotFixedNums + 1
                expvuls = append(expvuls, expvul)
            }else{
                WebRepairedNums = WebRepairedNums + 1
            }
        } (v)

    } // for _, v ...
    /* */
    wg.Wait()

    fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33,"==================Web Scan Results=====================\n" , 0x1B)
    fmt.Println("WebExecPoc: ",WebExecPoc)
    fmt.Println("WebRepairedNums: ",WebRepairedNums)
    fmt.Println("WebNotFixedNums:",WebNotFixedNums)
    fmt.Println("WebNotExecPocNums",WebNotExecPocNums)
    // TODO: should be type: ConfigCommon..
    rp.RCExploredVulns      = expvuls
    /* */
    rp.RCReportedAt         = time.Now()
    rp.RCElapsedTime        = time.Since(rp.RCExploredTimeAt)
    /*Exec result */
    rp.RCExecPocNums       = WebExecPoc
    rp.RCRepairedNums      = WebRepairedNums
    rp.RCNotFixedNums      = WebNotFixedNums
    rp.RCNotExecPocNums    = WebNotExecPocNums

    return rp
}

func
(dtr *doctor)GenmaiFastScan() (map[string]interface{},map[string]interface{}){
    Port,_:=strconv.Atoi(dtr.Port)
    resultMap,resultMapNotIn:=FastScan.GetdpkgInfo(dtr.Username,dtr.Passwd_nor,dtr.Host,Port)
    return resultMap,resultMapNotIn
}


func
(dtr *doctor)LoadExplorersListConfig(configf string) (rc error) {
    var parser ConfigParserBase

    filetype := GetSubfixFile(configf)
    /* */
    if  ( (".yml"  == filetype) ||
          (".yaml" == filetype)      ) {
        A_DEBUG_INFO("Got a YAML:", configf)
        /* */
        parser = &ConfigParserYAML{}
    } else if ( (".json" == filetype) ) {
        A_DEBUG_INFO("Got a YAML:", configf)
        /* */
        parser = &ConfigParserJSON{}
    } else {
        A_DEBUG_WARNING("Can not determine WHAT format is! file:", configf)
        parser = &ConfigParserDefault{}
    }


    parser.Mashal(configf)

    elc := ExplorersListConfig{}
    rc = mapstructure.Decode(parser, &elc)
    /* */
    if (nil != rc) {
        A_DEBUG_ERROR(rc)
        /* */
        return rc
    }

    dtr.TargetIps   = elc.TargetIps
    dtr.TargetPorts = elc.TargetPorts

        switch (elc.Type) {
            case EXP_TYPE_DBus:
                // dtr.PushExplorerDBus(exp.ConfigFile)
            case EXP_TYPE_KERNEL:
                for _, exp := range elc.ExplorerItems {
                    dtr.PushExplorerKernel(elc.ConfigFilePrefix + exp.ConfigFile)
                } // for exp ...
            case EXP_TYPE_SYSTEM:
                for _, exp := range elc.ExplorerItems {
                    dtr.PushExplorerSystem(elc.ConfigFilePrefix + exp.ConfigFile)
                } // for exp ...
            case EXP_TYPE_WEB:
                if (0 == len(dtr.TargetIps)) ||
                     (0 == len(dtr.TargetPorts))  {
                    A_DEBUG_ERROR("No Target-IP, or No Tar;get-Port!!!")
                    /* */
                    return fmt.Errorf("No Target-IP, or No Tar;get-Port!!!")
                } // if (0 == ...
                for _, targetip := range dtr.TargetIps {
                for _, targetport := range dtr.TargetPorts {
                    for _, exp := range elc.ExplorerItems {
                        dtr.PushExplorerWeb(elc.ConfigFilePrefix + exp.ConfigFile,
                                            targetip,
                                            targetport                              )
                    } // for exp ...
                } // for _, targetport ...
                } // for _, targetip ...
            case EXP_TYPE_BASELINE:
                for _, exp := range elc.ExplorerItems {
                    dtr.PushExplorerBaseLine(elc.ConfigFilePrefix + exp.ConfigFile)
                } // for exp ...
            default:
                A_DEBUG_ERROR("Unknow exp type!!")
        } // switch (exp.Type ...


    return rc
}

func
(dtr *doctor)PushExplorerDBus(configfile string) error {
//    // TODO: need to test
//    ed := ExplorerDBus{}
//    ed.Setup(&ConfigParserYAML{}, &ExplorerConfigDBus{})
//    ed.LoadConfig(configfile)
//
//    ed.SetupSandbox(&sandbox.SandboxDefault{})
//
//    config, rc := ed.GetExplorerConfigDBus()
//    /* */
//    if (nil != rc) {
//        return rc
//    } // if (nil != ...
//
//    dtr.ExplorersDBus[config.Id] = ed

    return nil
}

func
(dtr *doctor)PushExplorerKernel(configfile string) error {
    // TODO: need to test
    ek := ExplorerKernel{}
    ek.Setup(&ConfigParserYAML{}, &ExplorerConfigKernel{})
    ek.LoadConfig(configfile)
    ek.SetupSandbox(&sandbox.SandboxDefault{})

    config, rc := ek.GetExplorerConfigKernel()
    /* */
    if (nil != rc) {
        return rc
    } // if (nil != ...

    dtr.ExplorersKernel[config.Id] = ek

    return nil
}

func
(dtr *doctor)PushExplorerSystem(configfile string) error {
    //fmt.Println(configfile)
    // TODO: need to test
    ek := ExplorerSystem{}
    ek.Setup(&ConfigParserYAML{}, &ExplorerConfigSystem{})
    ek.LoadConfig(configfile)

    ek.SetupSandbox(&sandbox.SandboxDefault{})

    config, rc := ek.GetExplorerConfigSystem()
    /* */
    if (nil != rc) {
        return rc
    } // if (nil != ...
    dtr.ExplorersSystem[config.Id] = ek

    return nil
}

func
(dtr *doctor)PushExplorerWeb(configfile string, targetip string, targetport string) error {
    // TODO: need to test
    ek := ExplorerWeb{}
    ek.Setup(&ConfigParserYAML{}, &ExplorerConfigWeb{})
    ek.LoadConfig(configfile)

    ek.SetupSandbox(&sandbox.SandboxDefault{})

    config, rc := ek.GetExplorerConfigWeb()
    /* */
    if (nil != rc) {
        return rc
    } // if (nil != ...

    ek.TargetIp = targetip
    ek.TargetPort = targetport
    /* */
    dtr.ExplorersWeb[config.Id] = ek

    return nil
}


func
(dtr *doctor)PushExplorerBaseLine(configfile string) error {
    // TODO: need to test
    eb := ExplorerBaseLine{}
    eb.Setup(&ConfigParserYAML{}, &ExplorerConfigBaseLine{})
    eb.LoadConfig(configfile)
    config, rc := eb.GetExplorerConfigBaseLine()
    /* */
    if (nil != rc) {
        return rc
    } // if (nil != ...

    eb.Passwd = dtr.Passwd
    dtr.ExplorersBaseLine[config.Id] = eb
    return nil
}
func
(dtr *doctor)SetDoctorVal(passwd string,username string,passwd_nor string,Time string,host string,port string){
    dtr.Passwd = passwd
    dtr.Username = username
    dtr.Passwd_nor = passwd_nor
    dtr.StartTime = Time
    dtr.Host = host
    dtr.Port = port

}
func(dtr *doctor)ExecEmpowerment(path string){
    cmd := exec.Command("chmod", "+x", path)
	err := cmd.Run()
	if err != nil {
        fmt.Println("cmd.Run() failed with %s\n", err)
		// log.Fatalf("cmd.Run() failed with %s\n", err)
	}
}
func
(dtr *doctor)BaseLineControl(v interface{})(bool){
    IfRootPower:=v.(ExplorerBaseLine).ExplorerCommon.EcConfig.(*ExplorerConfigBaseLine).Power
    if IfRootPower=="root" && dtr.Passwd ==""{
        return true
    }else{

        // replace macro with real value
        imarray := v.(ExplorerBaseLine).ExplorerCommon.EcConfig.(*ExplorerConfigBaseLine).SiteRequests.ImArray
        var MacroConst map[string]string
        MacroConst= make(map[string]string)

        //
        MacroConst["${USERNAME}"]=dtr.Username
        MacroConst["${PASSWORD}"]=dtr.Passwd_nor
        MacroConst["${ROOTPASSWORD}"]=dtr.Passwd

        id := v.(ExplorerBaseLine).ExplorerCommon.EcConfig.(*ExplorerConfigBaseLine).Id

        for _, im := range imarray {
            for j, arg := range im.Args {

                if arg == "${USERNAME}" {
                    if dtr.Username =="false"{
                        // infoWarn:="Baseline warning: "+id+" username not configured, unable to perform full detection "
                        // fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
                    }else{
                        im.Args[j] = dtr.Username
                    }
                }
                if arg == "${PASSWORD}" {
                    if dtr.Passwd_nor =="false"{
                        BaselineNeed = append(BaselineNeed,id)
                        BaselineStatus=1
                        // infoWarn:="Baseline warning: "+id+" username not configured, unable to perform full detection "
                        // fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
                    }else{
                        im.Args[j] = dtr.Passwd_nor
                    }
                }
                if arg == "${ROOTPASSWORD}" {
                    if dtr.Passwd ==""{
                        BaselineRootNeed = append(BaselineRootNeed,id)
                        BaselineStatus=1
                    }else{
                        // dtr.RootPasswdAuto()
                        im.Args[j] = dtr.Passwd
                    }
                }

                // for key, val := range MacroConst {
                //     im.Args[j] = strings.ReplaceAll(arg, key, val)
                //     fmt.Println(im.Args[j])
                // }
            }
        } // for im ...

        return false
    }
}
func
(dtr *doctor)KernelControl(v interface{})(bool){
    PocHazardLevel := v.(ExplorerKernel).ExplorerCommon.EcConfig.(*ExplorerConfigKernel).PocHazardLevel
    KernelExecDir  := v.(ExplorerKernel).ExplorerCommon.EcConfigFilePrefix
    config := v.(ExplorerKernel).ExplorerCommon.EcConfig.(*ExplorerConfigKernel).SiteRequests.ImArray
    var KernelExecFile string
    for _, im := range config{
        KernelExecFile = KernelExecDir+"/"+im.Exec
    }
    dtr.ExecEmpowerment(KernelExecFile)
    if PocHazardLevel =="low"{
        return false
    }else{
        return true
    }
}

func
(dtr *doctor)SystemControl(v interface{})bool{
    var constvul = true
    imarray := v.(ExplorerSystem).ExplorerCommon.EcConfig.(*ExplorerConfigSystem).SiteRequests.ImArray
    var MacroConst map[string]string
    MacroConst= make(map[string]string)
    // if dtr.Passwd == "" || dtr.Passwd_nor == "" || dtr.{
    //     return false
    // }else{
    //     MacroConst["${USERNAME}"]=dtr.Username
    //     MacroConst["${PASSWORD}"]=dtr.Username
    //     MacroConst["${ROOTPASSWORD}"]=dtr.Passwd

    //     for _, im := range imarray {
    //         for j, arg := range im.Args {
    //             for key, val := range MacroConst {
    //                 im.Args[j] = strings.ReplaceAll(arg, key, val)
    //             }
    //         }
    //     } // for im ...
    //     return true
    // }

    MacroConst["${USERNAME}"]=dtr.Username
    MacroConst["${PASSWORD}"]=dtr.Passwd_nor
    MacroConst["${ROOTPASSWORD}"]=dtr.Passwd

    id := v.(ExplorerSystem).ExplorerCommon.EcConfig.(*ExplorerConfigSystem).Id

    for _, im := range imarray {
        for j, arg := range im.Args {

            if arg == "${USERNAME}" {
                if dtr.Username =="false"{
                    // infoWarn:="System warning: "+id+" username not configured, unable to perform full detection "
                    // fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
                    constvul=false
                }else{
                    im.Args[j] = dtr.Username
                }
            }
            if arg == "${PASSWORD}" {
                if dtr.Passwd_nor =="false"{
                    SystemNeed = append(SystemNeed,id)
                    SystemStatus=1
                    constvul=false
                    // infoWarn:="System warning: "+id+" username not configured, unable to perform full detection "
                    // fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, infoWarn, 0x1B)
                }else{
                    im.Args[j] = dtr.Passwd_nor
                }
            }
            if arg == "${ROOTPASSWORD}" {
                if dtr.Passwd ==""{
                    constvul=false
                    SystemRootNeed = append(SystemRootNeed,id)
                    SystemStatus=1
                }else{
                    // dtr.RootPasswdAuto()
                    im.Args[j] = dtr.Passwd
                }
            }

            // for key, val := range MacroConst {
            //     im.Args[j] = strings.ReplaceAll(arg, key, val)
            //     fmt.Println(im.Args[j])
            // }
        }
    } // for im ...

    // for _, im := range imarray {
    //     for _, arg := range im.Args {
    //         for key, val := range MacroConst {
    //             fmt.Println(1,key)
    //             fmt.Println(2,val)
    //             fmt.Println(3,arg)
    //         }
    //     }
    // } // for im ...
    return constvul
}

// func
// (dtr *doctor) RootPasswdAuto()bool{
//     vul:="echo "+dtr.Passwd+" | su -c whoami"
//     cmd  := exec.Command("sh", "-c",vul)

//     stdoutStderr, err := cmd.CombinedOutput()
//     if err != nil {
//         log.Println(err)
//     }

//     fmt.Println("<<<<",stdoutStderr)
//     if strings.ContainsRune(stdoutStderr,"root"){
//         return true
//     }else{
//         return false
//     }
// }
