////////////////////////////////////////////////////////////////
//
//       Filename:  Utils.go
//
//        Version:  1.0
//        Created:  2022年11月08日 21时05分02秒
//       Revision:  none
//       Compiler:  go
//
//         Author:  alpha
//   Organization:  alpha
//       Contacts:  chenxinquan@kylinos.com
//
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Description:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Log:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Todo:
//
////////////////////////////////////////////////////////////////

package genmai

import (
    "fmt"
    "os"
    "os/exec"
    "runtime"
    "bytes"
    "strings"
    "regexp"
    "strconv"
    "log"
    "math/rand"
    "time"
    "gopkg.in/yaml.v2"
    "encoding/json"
    "net"
    "net/http"
    "io/ioutil"

)

type Response struct {
    Version string `json:"Version"`
    DateVersion string `json:"DateVersion"`
}
type Config struct {
    ServerAddress string `yaml:"serverAddress"`
	Version string `yaml:"version"`
    DateVersion string `json:"dateversion"`
}
var A_DEBUG_LEVEL int = 0
var A_DEBUG_NEED_HEAD bool = true
////////////////////////////////////////////////////////////////
// ALOG
const (
    A_DEBUG_LEVEL_INFO          int     = 0
    A_DEBUG_LEVEL_NOTE          int     = 1
    A_DEBUG_LEVEL_WARNING       int     = 2
    A_DEBUG_LEVEL_ERROR         int     = 3

    A_DEBUG_LEVEL_STR_INFO      string  = "[*] info"
    A_DEBUG_LEVEL_STR_NOTE      string  = "[?] note"
    A_DEBUG_LEVEL_STR_WARNING   string  = "[!] warning"
    A_DEBUG_LEVEL_STR_ERROR     string  = "[-] error"
)
func
A_DEBUG(head string, args ...interface{}) {
    if (true == A_DEBUG_NEED_HEAD) {
        fmt.Print(head)
    }

    fmt.Println(args...)
}

func
A_DEBUG_INFO(args ...interface{}) {
    if (A_DEBUG_LEVEL <= A_DEBUG_LEVEL_INFO) {
        A_DEBUG(A_DEBUG_LEVEL_STR_INFO + ":", args...)
    }
}
func
A_DEBUG_NOTE(args ...interface{}) {
    if (A_DEBUG_LEVEL <= A_DEBUG_LEVEL_NOTE) {
        A_DEBUG(A_DEBUG_LEVEL_STR_NOTE + ":", args...)
    }
}
func
A_DEBUG_WARNING(args ...interface{}) {
    if (A_DEBUG_LEVEL <= A_DEBUG_LEVEL_WARNING) {
        A_DEBUG(A_DEBUG_LEVEL_STR_WARNING + ":", args...)
    }
}
func
A_DEBUG_ERROR(args ...interface{}) {
    if (A_DEBUG_LEVEL <= A_DEBUG_LEVEL_ERROR) {
        A_DEBUG(A_DEBUG_LEVEL_STR_ERROR + ":", args...)
    }
}

////////////////////////////////////////////////////////////////
// File , Path
func
GetPrefixPath(path string) string {
    index := strings.LastIndex(path, string(os.PathSeparator))
    /* */
    return path[:index]
}

func
GetSubfixPath(path string) string {
    index := strings.LastIndex(path, string(os.PathSeparator))
    /* */
    return path[(index+1):]
}

func
GetSubfixFile(path string) string {
    index := strings.LastIndex(path, ".")
    /* */
    return path[index:]
}

////////////////////////////////////////////////////////////////
// Arg Security Check (SecCheck)
func
SecCheckArgs(targetString string) (LegalValue string) {
    match, err := regexp.MatchString(`^[a-zA-Z0-9,-]+$`, targetString)
       if err != nil {
          fmt.Println("参数不合规")
       }
    //    fmt.Println(match)
       LegalValue=strconv.FormatBool(match)
   return LegalValue
}

//IP校验
func
SecCheckIP(IP string) (matchResult string,List []string) {
    List =  make([]string,0)
    checkIP:=strconv.FormatBool(strings.Contains(IP, "/24"))
    if checkIP =="true"{
        //解析D段
        matchResult,List=SecCheckIPForD(IP)
    }else{
        match, err := regexp.MatchString(`^((0|[1-9]\d?|1\d\d|2[0-4]\d|25[0-5])\.){3}(0|[1-9]\d?|1\d\d|2[0-4]\d|25[0-5])$`, IP)
           if err != nil {
              fmt.Println(IP," 不合法请修改")
           }
           // fmt.Println(match)
        matchResult=strconv.FormatBool(match)
        List=append(List,IP)
    }
    return matchResult,List
}

//D段解析
func
SecCheckIPForD(IP string) (matchResult string,List []string) {
    List =  make([]string,0)
    IP=strings.TrimRight(IP, "0/24")
    for i:=0;i<=255;i++{
        vul:=strconv.Itoa(i)
        IPVul:=IP+vul
        match, err := regexp.MatchString(`^((0|[1-9]\d?|1\d\d|2[0-4]\d|25[0-5])\.){3}(0|[1-9]\d?|1\d\d|2[0-4]\d|25[0-5])$`, IPVul)
           if err != nil {
              fmt.Println(IPVul," 不合法请修改")
           }
        matchResult=strconv.FormatBool(match)
        if matchResult=="true"{
            List=append(List,IPVul)
        }else{
            log.Println("D段解析错误")
        }
    }
    return matchResult,List
}

// 认证Root密码是否正确
func
RootPasswdAuto(RootPasswd string)bool{
    
    if RootPasswd == ""{
        return true
    }

    c1 := exec.Command("echo", RootPasswd)
    c2 := exec.Command("su","-c","whoami")
    
    c2.Stdin, _ = c1.StdoutPipe()
    c2.Stdout = os.Stdout

    // fmt.Println(cmd)
	var stdout bytes.Buffer
	c2.Stdout = &stdout // 标准输出
	// cmd.Stderr = &stderr // 标准错误
    _ = c2.Start()
    _ = c1.Run()
    _ = c2.Wait() 
	// err := cmd.Run()
	// outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
    outStr:= string(stdout.Bytes())
	// if len(errStr)!=0{
    //     fmt.Println(errStr)
	// 	return false
	// }
	outStr=strings.TrimSpace(outStr)
    // fmt.Println(outStr)
	// if err != nil {
	// 	log.Fatalf("cmd.Run() failed with %s\n", errStr)
	// }
    // fmt.Println(1,outStr)
    if strings.Contains(outStr,"root"){
        return true
    }else{
        return false
    }
}
// 验证普通用户账号密码是否正确
func NorUserPasswdIsTrue(User string,passwd string)bool{
    if passwd == "false" || User == "false"{
        return true
    }
    c1 := exec.Command("echo", passwd)
    c2 := exec.Command("su",User,"-c","whoami")
    
    c2.Stdin, _ = c1.StdoutPipe()
    c2.Stdout = os.Stdout

    // fmt.Println(cmd)
	var stdout bytes.Buffer
	c2.Stdout = &stdout // 标准输出
	// cmd.Stderr = &stderr // 标准错误
    _ = c2.Start()
    _ = c1.Run()
    _ = c2.Wait() 
	// err := cmd.Run()

    outStr:= string(stdout.Bytes())

	outStr=strings.TrimSpace(outStr)
    
    if strings.Contains(outStr,User){
        return true
    }else{
        return false
    }
}
// 获取当前系统架构
func GetCurrentFw()(string,string){
    system:=runtime.GOOS
    arch:=runtime.GOARCH
    system = strings.TrimSpace(system)
    arch = strings.TrimSpace(arch)
    return system,arch
}

func RandStr() string {
    rand.Seed(time.Now().UnixNano())

    const letterBytes = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"

    b := make([]byte, 8)
    for i := range b {
        b[i] = letterBytes[rand.Intn(len(letterBytes))]
    }
    return string(b)
}
func GetdOpUInfo(command string)string{ 
	cmd := exec.Command("bash","-c",command)
	var stdout, stderr bytes.Buffer
	cmd.Stdout = &stdout // 标准输出
	cmd.Stderr = &stderr // 标准错误
	err := cmd.Run()
	outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
	if len(errStr)!=0{
		fmt.Println(errStr)
	}
	outStr = strings.TrimSpace(outStr)
	if err != nil {
		log.Println("cmd.Run() failed with %s\n", errStr)
	}
    return outStr
}
func Host_target()string {
    var Ipnet string
    addrs, _:= net.InterfaceAddrs()

    for _, address := range addrs {
        // 检查地址是否为IPv4地址
        if ipnet, ok := address.(*net.IPNet); ok && !ipnet.IP.IsLoopback() && ipnet.IP.To4() != nil {
           Ipnet = ipnet.IP.String()
        }
    }
    return Ipnet
}
func GetdOpInfo()string{
	command:="cat /etc/os-release | awk 'NR==14{print $1}'"   
	cmd := exec.Command("bash","-c",command)
	var stdout, stderr bytes.Buffer
	cmd.Stdout = &stdout // 标准输出
	cmd.Stderr = &stderr // 标准错误
	err := cmd.Run()
	outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
	if len(errStr)!=0{
		fmt.Println(errStr)
	}
	outStr = strings.TrimSpace(outStr)
	if len(outStr) > 1 && outStr[len(outStr)-1] == '"'{
		outStr = outStr[:len(outStr)-1]
	}
	if err != nil {
		log.Println("cmd.Run() failed with %s\n", errStr)
	}
    return outStr
}


func GetWebRequest_getVersion()(bool,bool){
    _,_,ServerAddress:=ConfigYamlParse()
    url := "http://"+ServerAddress+"/mock-server/api/getVersion"
    resp,err := http.Get(url)
    if err !=nil {
        //fmt.Println(err)
        return false,false
    }
    defer resp.Body.Close()

    body,_ := ioutil.ReadAll(resp.Body)
    // if err !=nil {
    //     fmt.Println(err)
    //     return
    // }
    var data Response
    _ = json.Unmarshal(body,&data)
    
    rv,rdv:=Compare(data.Version, data.DateVersion)
    var rvbool bool = false
    var rdvbool bool = false
    if rv == 1{
        rvbool = true
    }
    if rdv == 1{
        rdvbool = true
    }
    return rvbool,rdvbool
    // fmt.Println(data.Version)
    // return data.Version, data.DateVersion
}
func UploadFile_src(username string,password string,host string,port string){
    _,_,ServerAddress:=ConfigYamlParse()
    url := "http://"+ServerAddress+"/mock-server/api/updateSrc"
    value:="username="+username+"&password="+password+"&host="+host+"&port="+port
    payload := strings.NewReader(value)
    req,err := http.NewRequest("POST",url,payload)
    if err !=nil {
        fmt.Println(err)
        return
    }
    req.Header.Set("Content-Type","application/x-www-form-urlencoded")
    client := &http.Client{}
    resp,err := client.Do(req)
    if err !=nil {
        fmt.Println(err)
        return
    }
    defer resp.Body.Close()

    body,err := ioutil.ReadAll(resp.Body)
    if err !=nil {
        fmt.Println(err)
        return
    }
    fmt.Println(string(body))
    // if err !=nil {
    //     fmt.Println(err)
    //     return
    // }
    // var data Response
    // _ = json.Unmarshal(body,&data)
}
func UploadFile_data(username string,password string,host string,port string){
    _,_,ServerAddress:=ConfigYamlParse()
    url := "http://"+ServerAddress+"/mock-server/api/updateData"
    value:="username="+username+"&password="+password+"&host="+host+"&port="+port
    payload := strings.NewReader(value)
    req,err := http.NewRequest("POST",url,payload)
    if err !=nil {
        fmt.Println(err)
        return
    }
    req.Header.Set("Content-Type","application/x-www-form-urlencoded")
    client := &http.Client{}
    resp,err := client.Do(req)
    if err !=nil {
        fmt.Println(err)
        return
    }
    defer resp.Body.Close()

    body,err := ioutil.ReadAll(resp.Body)
    if err !=nil {
        fmt.Println(err)
        return
    }
    fmt.Println(string(body))
    // if err !=nil {
    //     fmt.Println(err)
    //     return
    // }
    // var data Response
    // _ = json.Unmarshal(body,&data)
}
func Compare(version string,dateversion string)(int,int){
    localVersion,localDateVersion,_:=ConfigYamlParse()
    v1 := strings.Split(version,".")
    v2 := strings.Split(localVersion,".")
    dv1 := strings.Split(dateversion,".")
    dv2 := strings.Split(localDateVersion,".")
    rv:=CompareVersion(v1,v2)
    rdv:=CompareDataVersion(dv1,dv2)
    return rv,rdv
}
func CompareVersion(v1 []string,v2 []string)int{
    // 二进制文件版本比对大小
    if len(v1) > len(v2){
        for i:=0; i < len(v2);i++ {
            ver1,_ := strconv.Atoi(v1[i])
            ver2,_ := strconv.Atoi(v2[i])
            if ver1 < ver2 {
                return 2
            }else if ver1 > ver2 {
                return 1
            }
        }
        return 1
    }else if len(v1) < len(v2) {
        for i:=0; i < len(v1[i]);i++ {
            ver1,_ := strconv.Atoi(v1[i])
            ver2,_ := strconv.Atoi(v2[i])
            if ver1 < ver2 {
                return 2
            }else if ver1 > ver2 {
                return 1
            }
        }
        return 2
    }else {
        for i:=0; i < len(v1);i++ {
            ver1,_ := strconv.Atoi(v1[i])
            ver2,_ := strconv.Atoi(v2[i])
            
            if ver1 < ver2 {
                return 2
            }else if ver1 > ver2 {
                return 1
            }
        }
        return 0
    }
}
func CompareDataVersion(dv1 []string,dv2 []string)int{
    // 数据版本比对大小
    if len(dv1) > len(dv2){
        for i:=0; i < len(dv2);i++ {
            dver1,_ := strconv.Atoi(dv1[i])
            dver2,_ := strconv.Atoi(dv2[i])
            if dver1 < dver2 {
                return 2
            }else if dver1 > dver2 {
                return 1
            }
        }
        return 1
    }else if len(dv1) < len(dv2) {
        for i:=0; i < len(dv1[i]);i++ {
            dver1,_ := strconv.Atoi(dv1[i])
            dver2,_ := strconv.Atoi(dv2[i])
            if dver1 < dver2 {
                return 2
            }else if dver1 > dver2 {
                return 1
            }
        }
        return 2
    }else {
        for i:=0; i < len(dv1);i++ {
            dver1,_ := strconv.Atoi(dv1[i])
            dver2,_ := strconv.Atoi(dv2[i])
            if dver1 < dver2 {
                return 2
            }else if dver1 > dver2 {
                return 1
            }
        }
        return 0
    }
}
func ConfigYamlParse()(string,string,string){
    data, err := ioutil.ReadFile("config.yaml")
	if err != nil {
		log.Println(err)
	}

	// 解析 YAML 数据
	var config Config
	err = yaml.Unmarshal(data, &config)
	if err != nil {
		log.Println(err)
	}

	return config.Version,config.DateVersion,config.ServerAddress
}

// 检测目录是否存在
////////////////////////////////////////////////////////////////
func IsDirExisted (dir string) bool{

    _, err := os.Stat(dir)
    if os.IsNotExist(err) {
        return false
    } else {
        return true
    }
}
////////////////////////////////////////////////////////////////
// 检测目录是否存在

//文件检测是否存在
func PathExists(path string)(bool,error){
    _,err := os.Stat(path)
    if err == nil{
        return true,nil
    }
    //isnotexist来判断，是不是不存在的错误
    if os.IsNotExist(err){	//如果返回的错误类型使用os.isNotExist()判断为true，说明文件或者文件夹不存在
        return false,nil
    }
    return false,err//如果有错误了，但是不是不存在的错误，所以把这个错误原封不动的返回
}
