package genmai

import (
    "os"
    "log"
    "os/user"
)
 
func LogInit() {
    currentUser, err := user.Current()
    if err != nil {
       log.Fatalf(err.Error())
    }
    username := currentUser.Username
    // 获取日志文件句柄
    path:="/tmp/GenmaiLog_"+username
    CreateDir(path)
    // 以 只写入文件|没有时创建|文件尾部追加 的形式打开这个文件
    currentFilePath:=path+"/logfile"
    logFile, err := os.OpenFile(currentFilePath, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
    if err != nil {
        panic(err)
    }
    // 设置存储位置
    log.SetOutput(logFile)
}
//判断文件夹是否存在
func HasDir(path string) (bool, error) {
    _, _err := os.Stat(path)
    if _err == nil {
        return true, nil
    }
    if os.IsNotExist(_err) {
        return false, nil
    }
    return false, _err
}
  
//创建文件夹
func CreateDir(path string) {
    _exist, _err := HasDir(path)
    if _err != nil {
        A_DEBUG_ERROR("Get folder exception -> %v\n", _err)
        return
    }
    if _exist {
        A_DEBUG_INFO("info:GenmaiLog have been existed.")
    } else {
        err := os.Mkdir(path, os.ModePerm)
        if err != nil {
            A_DEBUG_ERROR("There are GenmaiLog directory creation exceptions -> %v\n", err)
        } else {
            A_DEBUG_INFO("GenmaiLog created successfully!")
        }
    }
}