package main

import (
    "main/genmai/FrameWorkCheck"
    "flag"
    "log"
    "time"
    "strconv"
    "fmt"
    "encoding/json"
    "os"
    // "compress/gzip"
    "io"
    "bytes"
    "os/exec"
    "strings"
    genmai "main/genmai"
    "main/tools/SSHExplosion"
    "main/tools/Kybuilder"
    "main/tools/FastScan"
    "main/genmai/RemoteCheck"
    // gcon   "main/gconsole"
    "archive/tar"
    "bufio"
    "path/filepath"
    // TODO: 进度条：暂时无法实现：获取不了解压后的文件大小
    // "github.com/cheggaaa/pb/v3"
    "github.com/ulikunitz/xz"
)
type Args struct{
    ParserNum           int         //协程数
    System              string      //执行系统漏洞检测
    Web                 string      //Web漏洞检测
    Kernel              string      //内核漏洞检测
    Fuzz                string      //Fuzz
    BaseLine            string      //基线检测
    Update              string      //更新软件
    Docx                string      //生成报告
    Pdf                 string      //生成报告
    PoolStatNum         int         //启动协程任务数
    IP                  string      //web 制定IP
    MD                  string      //生成MD文件
    RemoteAssessment    string      //远程检测,所需参数在RAVUL中
    WKPWD               string      //弱口令生成,所需参数在WKPWDVUL结构体中
    SSHBurst            string      //SSH爆破
    Nmap                string      //Nmap模块,端口和IP放在RAVUL中
    IsoScan             string      //Iso扫描模块
    Fofa                string      //fofa接口调用，需要输入查询命令
    FastScan            string      //快速扫描模式/版本匹配
    OutPutJson          string      //输出json格式结果
    RootPasswd          string      //Root密码
    Repair              string      //一键修复
}

type FofaCommand struct{
    FofaCom             string
}

type RAVUL struct{
    Host                string      //主机IP
    User                string      //用户名
    Password            string      //密码
    Port                string      //端口
}

type WKPWDVUL struct{
    CompanyName         string      //公司名
    Name                string      //名字
    Nums                string      //特殊数字
}


type Config struct {
    ConfigFilePrefix string            `yaml:"ConfigFilePrefix"`
    Type             string            `yaml:"Type"`
    ExplorerItems    []ExplorerItem    `yaml:"ExplorerItems"`
}

type ExplorerItem struct {
    ConfigFile string `yaml:"ConfigFile"`
}

// 存储扫描结果结构体的map
var ScanResultKernel *genmai.ReportKernel;
var ScanResultSystem *genmai.ReportSystem;
var ScanResultBaseline *genmai.ReportBaseLine;
var FastScanResult          map[string]interface {}
var FastScanNotInResult     map[string]interface {}
var IsoResult               map[string]interface {}
var IsoNotInResult          map[string]interface {}
// var ScanResultSystem ReportSystem;

func main(){
    graphic := `
                
      ██████╗ ███████╗███╗   ██╗███╗   ███╗ █████╗ ██╗
     ██╔════╝ ██╔════╝████╗  ██║████╗ ████║██╔══██╗██║
     ██║  ███╗█████╗  ██╔██╗ ██║██╔████╔██║███████║██║
     ██║   ██║██╔══╝  ██║╚██╗██║██║╚██╔╝██║██╔══██║██║
     ╚██████╔╝███████╗██║ ╚████║██║ ╚═╝ ██║██║  ██║██║
      ╚═════╝ ╚══════╝╚═╝  ╚═══╝╚═╝     ╚═╝╚═╝  ╚═╝╚═╝
                                    Author：2023©产品安全响应团队
                                    Version：0.8.1
`
    fmt.Println(graphic)
    stat_time:= time.Now().Format("15:04:05")
    // 定义存储扫描结果结构体的map
    // ScanResultMap = make(map[string]interface{})
    // ScanResultMap["system"]=0
    // /////////////////////////////
    // test "main/genmai"
    // genmai.Test()
    // config := genmai.NewConfig()
    // fmt.Println(">>")
    // fmt.Println(config["id"])
    // /////////////////////////////
    // test gconsole
    // gcon.Draw()

    // return


    var args Args //定义vul
    var RAV RAVUL
    var WKV WKPWDVUL
    var FC FofaCommand
    args.PoolStatNum =0

    //开始日志打印日志
    genmai.LogInit()

    //检测系统架构
    frameWork := FrameWorkCheck.FwCheck()
    if len(frameWork) > 0{
        log.Println("frameWork sure")
    }else{
        return
    }

    Help := flag.Bool("help", false,"")

    //识别参数，执行模块
    flag.IntVar(&args.ParserNum, "poolNums", 100,
                "设置协程的数量,默认数量为0,最大数量为1000")
    flag.StringVar(&args.Web, "web", "false",
                   "使用web漏洞的验证模块,可联合其他模块使用")
    flag.StringVar(&args.IP, "ip", "false",
                   "设置ip,可设置ip段进行验证")
    flag.StringVar(&args.System, "system", "false",
                   "使用系统漏洞的验证模块，可联合其他模块使用")
    flag.StringVar(&args.Kernel, "kernel", "false",
                   "使用内核漏洞的验证模块，可联合其他模块使用")
    flag.StringVar(&args.BaseLine, "baseline", "false",
                   "使用基线检测模块，可联合其他模块使用")
    flag.StringVar(&args.Repair, "repair", "false",
                   "使用基线检测模块，可联合其他模块使用")

    //远程模块参数
    RA := flag.Bool("RA", false,
                    "使用远程检测，只能单独使用模块")
    flag.StringVar(&RAV.Host, "host", "false", "IP")
    flag.StringVar(&RAV.Port, "port", "all", "端口")
    flag.StringVar(&RAV.User, "user", "false", "用户名")
    flag.StringVar(&RAV.Password, "passwd", "false", "远程登录密码")


    //需要高权限执行时所需要root密码
    flag.StringVar(&args.RootPasswd, "rootpwd", "", "需要高权限执行时所需要root密码")

    //弱密码生成模块
    WK := flag.Bool("WKPWD", false,
                    "使用弱口令生成器模块,选用参数CPN,Name,Nums")
    flag.StringVar(&WKV.CompanyName, "CPN", "0", "设置特定公司名")
    flag.StringVar(&WKV.Name, "Name", "0", "设置姓名")
    flag.StringVar(&WKV.Nums, "Nums", "0", "设置特殊数字（如年份）")

    // SSH爆破模块
    SSHB := flag.Bool("SSHBurst", false,
                      "使用SSH爆破,必用参数host,选用参数poolNums")

    // Nmap模块
    NmapScan := flag.Bool("Nmap",false,
                          "使用Nmap模块进行扫描,必用参数host,选用参数port")
    // Iso模块
    flag.StringVar(&args.IsoScan, "Iso", "null", "Iso扫描模块,Iso为auto则为自动获取build号否则后接build号")
    
    // Fofa模块
    Fofa := flag.Bool("Fofa",false,
                      "Fofa探测,必用参数FofaCom")
    flag.StringVar(&FC.FofaCom, "fofaCom", "null", "设置特定公司名")

    //版本匹配，快速扫描
    FastScan := flag.Bool("FastScan", false, "版本匹配，快速检测漏洞")

    //////// 输出文件格式 ////////
    // 输出json格式文件
    flag.StringVar(&args.OutPutJson, "OutPutJson", "null",
                   "将漏洞扫描模块输出结果转成json文件")
    // 输出docx格式文件
    flag.StringVar(&args.Docx, "Docx", "null",
                    "将漏洞扫描模块输出结果转成json文件")
    // 输出PDF格式文件
    flag.StringVar(&args.Pdf, "Pdf", "null",
                    "将漏洞扫描模块输出结果转成json文件")
    ///////////////////////////
    ///////////////////////////

    //
    All := flag.Bool("all", false,
                     "只扫描system,kernel的所有poc以及检测baselin模块,不可联合其他参数使用")

    Update := flag.Bool("update", false,
                        "更新程序到最新版本，不可联合其他参数使用")

    //flag解析
    flag.Parse()

    // Start Time
    Time:=time.Now().Format("2006-01-02 15:04:05")

    // // root Password Auto
    // re:=genmai.RootPasswdAuto(args.RootPasswd)
    // if re == false{
    //     fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 31, "ERROR: Root password error", 0x1B)
    //     return
    // }
    // // 普通用户账号密码检测
    // reNor:=genmai.NorUserPasswdIsTrue(RAV.User,RAV.Password)
    // if reNor == false{
    //     fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 31, "ERROR: Account password error", 0x1B)
    //     return
    // }


    //将插件模块的值存放到数组中
    //PWDList :=[...]string{WKV.CompanyName,WKV.Name,WKV.Nums}
    //poolNums := strconv.Itoa(args.ParserNum)
    // SSHBurstList :=[...]string{RAV.Host,poolNums}
    // NmapScanList :=[...]string{RAV.Host,RAV.Port}

    //初始化bool值
    sAll := strconv.FormatBool(*All)
    args.Update=strconv.FormatBool(*Update)
    args.RemoteAssessment=strconv.FormatBool(*RA)
    args.WKPWD=strconv.FormatBool(*WK)
    help := strconv.FormatBool(*Help)
    args.SSHBurst =strconv.FormatBool(*SSHB)
    args.Nmap = strconv.FormatBool(*NmapScan)
    args.Fofa = strconv.FormatBool(*Fofa)
    args.FastScan = strconv.FormatBool(*FastScan)

    //输出格式选择
    // if args.OutPutJson =="null"{
   //      fmt.Printf("%c[%d;%d;%dm%s%c[0m\n", 0x1B, 0, 0, 33, "Warn: No output format specified , please enter", 0x1B)
     //}else{
       //  var OutPutJson string ="true"
        //fmt.Println(args.OutPutJson)
         //return
     //}

    ////////////////
    // 参数逻辑
    if (args.System=="false" &&
        args.Kernel=="false" &&
        args.Web=="false" &&
        args.BaseLine=="false" &&
        args.FastScan=="false" &&
        args.Fofa=="false" &&
        args.Nmap=="false" &&
        args.IsoScan=="null"&&
        args.Repair=="false" &&
        args.Update!="true" &&
        sAll!="true" &&
        help!="true"          ) {
            genmai.A_DEBUG_WARNING("Please enter parameters!")
        return
    }
    if (args.FastScan != "false" && args.IsoScan != "null"){
        genmai.A_DEBUG_WARNING("Cannot use both iso scanning and fast scanning simultaneously!")
        return
    }

    //协程最大值为200
    if args.ParserNum<0 || args.ParserNum>500{
        fmt.Println("协程最大值为0-500")
        return
    }else{
        poolNum:= args.ParserNum
        fmt.Println("[*] info:Genmai enable default coprocess",poolNum)
    }

    // Help
    if help=="true"{
        flag.PrintDefaults()
    }
    // 参数逻辑
    ////////////////


    rv,rdv:=genmai.GetWebRequest_getVersion()

    if rv {
        if rdv {
            fmt.Println("data,src")
            genmai.UploadFile_src(RAV.User,RAV.Password,RAV.Host,RAV.Port)
            genmai.UploadFile_data(RAV.User,RAV.Password,RAV.Host,RAV.Port)
            return
        }else{
            fmt.Println("src")
            genmai.UploadFile_src(RAV.User,RAV.Password,RAV.Host,RAV.Port)
            return
        }
    }
    if rdv {
        fmt.Println("data")
        genmai.UploadFile_data(RAV.User,RAV.Password,RAV.Host,RAV.Port)
        return
    }
    var rootInt int = 0
    // fmt.Println(1,RAV.Password,2,args.RootPasswd,3,args.RemoteAssessment)
   if RAV.Password != "false" && args.RootPasswd == "" && args.RemoteAssessment !="true"{
        // 检测 root 用户是否已启用
        if isRootEnabled(RAV.Password)!=0 {
            rootInt = 1
            // 创建 root 用户密码
            createRootPassword(RAV.Password)
            args.RootPasswd=RAV.Password
            // 修改 sshd 配置文件，允许 root 用户登陆
            modifySshdConfig(RAV.Password)

            // 重启 sshd 服务
            restartSshdService(RAV.Password)
        }else{
            log.Println("当前用户非sudo用户,无法自动配置root环境")
            fmt.Println("当前用户非sudo用户,无法自动配置root环境")
        }
   }

    // Use the root password to perform higher authority detection
    genmai.DoctorIns().SetDoctorVal(args.RootPasswd,RAV.User,RAV.Password,Time,RAV.Host,RAV.Port)

    // 程序执行
    emmit(args, RAV, WKV, FC)
    if rootInt == 1{
        //fmt.Println("\n","==================  Restoring  status  =====================","\n")

        // 恢复 sshd 配置文件
        restoreSshdConfig(RAV.Password)

        // 删除 root 用户密码
        deleteRootPassword(RAV.Password)
    }

    if (args.Docx != "null"){
        genmai.Createdocx_fun(args.Docx,stat_time,RAV.Host,
                             ScanResultKernel,
                             ScanResultSystem,
                             ScanResultBaseline,
                             FastScanResult,
                             FastScanNotInResult,
                             IsoResult,
                             IsoNotInResult)
    }

    if (args.Pdf != "null"){
        genmai.Createpdf_fun(args.Pdf, stat_time,RAV.Host,
                             ScanResultKernel,
                             ScanResultSystem,
                             ScanResultBaseline,
                             FastScanResult,
                             FastScanNotInResult,
                             IsoResult,
                             IsoNotInResult)
    }
    return
}

func emmit(args Args, RAV RAVUL, WKV WKPWDVUL, FC FofaCommand) {
    poolNums := strconv.Itoa(args.ParserNum)
    //是否开启远程检测
    if args.RemoteAssessment=="true"{
        var RemoteMap map[string]string
        RemoteMap= make(map[string]string)
        RemoteMap["host"]= RAV.Host
        RemoteMap["port"]= RAV.Port
        RemoteMap["user"]= RAV.User
        RemoteMap["password"]= RAV.Password
        RemoteMap["system"]= args.System
        RemoteMap["kernel"]= args.Kernel
        RemoteMap["baseline"]= args.BaseLine
        RemoteMap["RootPasswd"]= args.RootPasswd
        RemoteMap["FastScan"]= args.FastScan
        genmaiRemote(args,RemoteMap)
    }else{

        ///////////////////////////////
        // python虚拟配置环境
        _,arch := genmai.GetCurrentFw()
        dir :="../data/SandboxViPyEnv/"+arch
        re := genmai.IsDirExisted(dir)
        if !re  {
            untarSandboxViPyEnv()
            command_kysec:="kysec_set -rn exectl -v verified /home/"+RAV.User+"/genmai"
            // fmt.Println(command_kysec)
            cmd := exec.Command("bash", "-c", command_kysec)
            err := cmd.Run()
            if err != nil {
                fmt.Println(err)
                return
            }
            // _,arch:=genmai.GetCurrentFw()
            // interpreter := "../data/SandboxViPyEnv/"+arch+"/myenv/bin/python3"
            // chmodInterpreter := exec.Command("chmod","+x",interpreter)
            // output,err:=chmodInterpreter.Output()
            // if err != nil {
            //     fmt.Println(err)
            // }
            // fmt.Println(output)
        }

        ///////////////////////////////

        ///////////////////////////////
        // 基础模块

        // System
        if ("false" != args.System) {
            genmaiSystem(args)
        } // if ("flase ...

        // Kernel
        if ("false" != args.Kernel) {
            genmaiKernel(args)
        } // if ("flase ...

        // Web
        if args.Web!="false" && args.IP!="false"{
            genmaiWeb(args)
        }else if args.Web!="false" && args.IP=="false"{
            fmt.Println("请输入IP参数")
            return
        }else if args.Web=="false" && args.IP!="false"{
            fmt.Println("请输入web参数")
            return
        }

        // BaseLine
        if args.BaseLine!="false"{
            genmaiBaseLine(args)
        }

        // 基础模块
        ///////////////////////////////

        // ArgParser.WKPWD(args.WKPWD,PWDList[:])
        if ("true" == args.WKPWD) {
            //将插件模块的值存放到数组中
            PWDList :=[...]string{WKV.CompanyName,WKV.Name,WKV.Nums}
            genmaiWKPWD(args.WKPWD, PWDList[:]);
        } // if ("true ...

        // ArgParser.SSHBurst(args.SSHBurst,SSHBurstList[:])
        if ("true" == args.SSHBurst) {
            //将插件模块的值存放到数组中
            SSHBurstList :=[...]string{RAV.Host,poolNums}
            genmaiSSHBurst(args.SSHBurst,SSHBurstList[:])
        } // if ("true ...

        // ArgParser.NmapScan(args.Nmap, NmapScanList[:])
        if ("true" == args.Nmap) {
            NmapScanList :=[...]string{RAV.Host,RAV.Port}
            genmaiNmapScan(args.Nmap, NmapScanList[:])
        } // if ("true ...

        if ("null" != args.IsoScan) {
            genmaiSystemIso(args.IsoScan,args)
            
        }

        // ArgParser.FofaApi(args.Fofa,FC.FofaCom)
        if ("true" == args.Fofa) {
            genmaiFofaApi(args.Fofa,FC.FofaCom)
        }
        if ("true" == args.FastScan) {
            genmaiSystemFastScan(args.FastScan,args)
        }
        if ("true" == args.Update){
            Update()
        }

    } // if args.RemoteAssessment=="true" ... else ...
}

////////////////////////////////////////////////////////////////
// genmai plug-in modules

////////////////////////////////////////////////////////////////
// 基础模块
func
genmaiSystem(args Args) {
    createfile_fun := func (rp *genmai.ReportSystem,
                            fileName string  ) {

        path:="../data/Report/"+"system_"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
        file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
        if err != nil {
            fmt.Println("open file failed,err:",err)
            return
        }
        defer file.Close()
        jsonVul, err := json.MarshalIndent(rp, "", "     ")
        if err != nil {
            fmt.Println("json err ", err)
        }
        file.Write([]byte(jsonVul))    //写入字节切片数据
    } // createfile_fun

    fun := func (jout string,Docx string, Pdf string) {

        genmai.A_DEBUG_INFO(">>Genmai System Poc Scan...")
        rp := genmai.DoctorIns().GenmaiSystem()
        if len(rp.RCExploredVulns)==0{
            //fmt.Println("System info: No vulnerability")
            if jout != "null"{
                createfile_fun(rp,jout)
            }
            if Docx != "null"{
                ScanResultSystem = rp
            }
            if Pdf != "null"{
                ScanResultSystem = rp
            }
        }else{
            if jout !="null"{
                createfile_fun(rp,jout)
            }
            if Docx !="null"{
                ScanResultSystem=rp
            }
            if Pdf !="null"{
                ScanResultSystem=rp
            }

        }
    }

    if args.System=="All" || args.System=="all"{
        path:="../data/SystemPocs/SystemPocs.yaml"
        genmai.DoctorIns().Reset()
        genmai.DoctorIns().LoadExplorersListConfig(path)

        fun(args.OutPutJson,args.Docx, args.Pdf)
    }else{
        //检测函数检测安全性
        //单独检查某个项目
        LegalSystem:=genmai.SecCheckArgs(args.System)
        if LegalSystem=="true"{
            if args.System !="KVE" && args.System !="CVE"{
                pocsPath := strings.Split(args.System,",")
                genmai.DoctorIns().Reset()
                for i:=0;i<len(pocsPath);i++{
                    filePath:="../data/SystemPocs/"+pocsPath[i]+"/"+pocsPath[i]+".yaml"
                    path:="../data/SystemPocs/"+pocsPath[i]
                    if genmai.IsDirExisted(path) {
                        genmai.DoctorIns().PushExplorerSystem(filePath)
                    }else{
                        genmai.A_DEBUG_ERROR(pocsPath[i]+" does not exist!!!")
                        return
                    }
                }
                fun(args.OutPutJson,args.Docx, args.Pdf)
            }else{
                genmai.DoctorIns().Reset()
                err:= filepath.Walk("../data/SystemPocs/", func(path string, info os.FileInfo, err error) error {
                    if err != nil{
                        return err
                    }
                    if info.IsDir() && strings.Contains(info.Name(),args.System){
                        filePath:="../data/SystemPocs/"+info.Name()+"/"+info.Name()+".yaml"
                        path:="../data/SystemPocs/"+info.Name()
                        if genmai.IsDirExisted(path) {
                            genmai.DoctorIns().PushExplorerSystem(filePath)
                        }else{
                            genmai.A_DEBUG_ERROR(info.Name()+" does not exist!!!")
                        }
                    }
                    return nil
                })
                if err !=nil{
                    fmt.Println(err)
                    return
                }
                fun(args.OutPutJson,args.Docx, args.Pdf)
            }
        }else{
            genmai.A_DEBUG_ERROR("system参数不合规")
        }
    }
}

func
genmaiKernel(args Args) {
   createfile_fun := func (rp *genmai.ReportKernel,fileName string) {
        path:="../data/Report/"+"kernel_"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
       file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
       if err != nil {
           fmt.Println("open file failed,err:",err)
           return
       }

       defer file.Close()
       jsonVul, err := json.MarshalIndent(rp, "", "     ")
       if err != nil {
           fmt.Println("json err ", err)
       }
       file.Write([]byte(jsonVul))    //写入字节切片数据
   }

    fun := func (jout string,Docx string) {
        genmai.DoctorIns().Reset()
        genmai.DoctorIns().LoadExplorersListConfig("../data/KernelPocs/KernelPocs.yaml")

        genmai.A_DEBUG_INFO(">>Genmai Kernel>>")
        rp := genmai.DoctorIns().GenmaiKernel()
        if len(rp.RCExploredVulns)==0{
            fmt.Println("Kernel info: No vulnerability")
            if jout !="null"{
                createfile_fun(rp,jout)
            }
            if Docx !="null"{
                ScanResultKernel =rp
            }
        }else {
            if jout !="null"{
                createfile_fun(rp,jout)
            }
            if Docx !="null"{
                ScanResultKernel=rp
            }
        }
    }

        if args.Kernel=="All" || args.Kernel=="all"{
            fun(args.OutPutJson,args.Docx)
        }else{
            //检测函数检测安全性
            //单独检查某个项目
            LegalKernel:=genmai.SecCheckArgs(args.Kernel)
            if LegalKernel=="true"{
                // fun(args.OutPutJson,args.Docx)
                fmt.Println("该模块暂不支持")
            }else{
                fmt.Println("kernel参数不合规")
            }
        }
}

func
genmaiWeb(args Args) {
    createfile_fun := func (rp *genmai.ReportWeb,
                            fileName string  ) {

        path:="../data/Report/"+"web_"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
        file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
        if err != nil {
            fmt.Println("open file failed,err:",err)
            return
        }
        defer file.Close()
        jsonVul, err := json.MarshalIndent(rp, "", "     ")
        if err != nil {
            fmt.Println("json err ", err)
        }
        file.Write([]byte(jsonVul))    //写入字节切片数据
    } // createfile_fun

    fun := func (jout string) {
        genmai.DoctorIns().Reset()
        genmai.DoctorIns().LoadExplorersListConfig("../data/WebPocs/WebPocs.yaml")

        genmai.A_DEBUG_INFO(">>Genmai Web>>")
        rp := genmai.DoctorIns().GenmaiWeb()
        if len(rp.RCExploredVulns)==0{
            fmt.Println("Web info: No vulnerability")
            if jout !="null"{
                createfile_fun(rp,jout)
            }
        }else if jout !="null"{
            createfile_fun(rp,jout)
        }
    }

        var ipCheck string
        // ipList :=  make([]string,0)

        if args.Web=="All" || args.Web=="all"{
            ipCheck,_=genmai.SecCheckIP(args.IP)
            if ipCheck=="true"{
                //Request["web"] = args.Web
                //Num=Num+1
                fun(args.OutPutJson)
            }else{
                fmt.Println("IP参数不合规")
            }
        }else{
            //检测函数检测安全性
            //单独检查某个项目
            LegalWeb:=genmai.SecCheckArgs(args.Web)
            ipCheck,_=genmai.SecCheckIP(args.IP)
            if ipCheck=="true"&&LegalWeb=="true"{
                //Request["web"] = args.Web
                //Num=Num+1
                fun(args.OutPutJson)
            }else{
                fmt.Println("参数不合规")
            }
        }
}
func
genmaiBaseLine(args Args) {
    createfile_fun := func (rp *genmai.ReportBaseLine, fileName string){
        path:="../data/Report/"+"baseline_"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
        file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
        if err != nil {
            fmt.Println("open file failed,err:",err)
            return
        }

        defer file.Close()
        jsonVul, err := json.MarshalIndent(rp, "", "     ")
        if err != nil {
            fmt.Println("json err ", err)
        }
        file.Write([]byte(jsonVul))    //写入字节切片数据
    }

    fun := func (jout string, Docx string, Pdf string) {
        genmai.DoctorIns().Reset()
        genmai.DoctorIns().LoadExplorersListConfig("../data/BaseLine/BaseLine.yaml")

        genmai.A_DEBUG_INFO(">>Genmai BaseLine>>")
        rp:=genmai.DoctorIns().GenmaiBaseline()
        if len(rp.RCExploredVulns)==0{
            fmt.Println("BaseLine info: No vulnerability")
            if jout !="null"{
                createfile_fun(rp,jout)
            }
            if Docx != "null"{
                ScanResultBaseline=rp
            }
            if Pdf != "null"{
                ScanResultBaseline=rp
            }
        }else{
            if jout !="null"{
                createfile_fun(rp,jout)
            }
            if Pdf !="null"{
                ScanResultBaseline=rp
            }
        }
    } // fun

    if args.BaseLine=="All" || args.BaseLine=="all"{
        fun(args.OutPutJson,args.Docx, args.Pdf)
    }else{
        //检测函数检测安全性
        //单独检查某个项目
        LegalBaseline:=genmai.SecCheckArgs(args.BaseLine)
        if LegalBaseline=="true"{
            // fun(args.OutPutJson,args.Docx, args.Pdf)
            fmt.Println("该模块暂不支持")
        }else{
            fmt.Println("BaseLine参数不合规")
        }
    }
}

//远程参数解析
func genmaiRemote(args Args, oldRemoteMap interface{})(){
    RemoteMap:=oldRemoteMap.(map[string]string)
    if RemoteMap["host"] !="false" && RemoteMap["user"] !="false" && RemoteMap["password"] !="false" && RemoteMap["port"] !="all"{
        SSHHostCheck,list:=genmai.SecCheckIP(RemoteMap["host"])
            if SSHHostCheck !="true"{
                fmt.Println("host错误",list)
            }else{
                var RemoteArg []string
                var constvul int = 0
                Host:=RemoteMap["host"]
                Port:=RemoteMap["port"]
                User:=RemoteMap["user"]
                Password:=RemoteMap["password"]
                RootPasswd:=RemoteMap["RootPasswd"]
                PortInt ,err:=strconv.Atoi(Port)
                if err!=nil{
                    fmt.Println(err)
                }
                if RemoteMap["kernel"]=="all" || RemoteMap["kernel"]=="All"{
                    RemoteArg =append(RemoteArg ,"kernel")
                    constvul = 1
                }
                if RemoteMap["system"]=="all" || RemoteMap["system"]=="All"{
                    RemoteArg =append(RemoteArg,"system")
                    constvul = 1
                }
                if RemoteMap["baseline"]=="all" || RemoteMap["baseline"]=="All"{
                    RemoteArg =append(RemoteArg,"baseline")
                    constvul = 1
                }
                if RemoteMap["FastScan"]=="true"{
                    RemoteArg =append(RemoteArg,"FastScan")
                    constvul = 1
                }
                if constvul == 1 {
                    re,_:=RemoteCheck.RemoteScan(Host,PortInt,User,Password,RemoteArg,RootPasswd)
                    if re==0{
                        fmt.Println("连接出错 检查输入参数是否正确")
                        log.Println("连接出错 检查输入参数是否正确")
                    }else if re == 101{
                        fmt.Println("更新失败请联系开发者")
                    }else if re == 100{
                        fmt.Println("更新成功请再次执行")
                    }
                }
                // if RemoteMap["FastScan"]=="true"{
                //     genmaiSystemFastScan(args.FastScan,args)
                // }
            }
    }
}

// 基础模块
////////////////////////////////////////////////////////////////

///////////////////////////////
//弱口令模块
func
genmaiWKPWD(WKPWD string ,PWDList []string) {
    PWD:=make(map[int]string)
    j:=0
    PWD[0] ="WeakPwdGeneration/WeakPwdGeneration" //文件名

    for i:=0;i<len(PWDList);i++{
        if PWDList[i]!="0" && i==0{
            j=j+1
            vul0:=" --CompanyName "+PWDList[0]
            PWD[j]=vul0
        }
        if PWDList[i]!="0" && i==1{
            j=j+1
            vul1:=" --Name "+PWDList[1]
            PWD[j]=vul1
        }
        if PWDList[i]!="0" && i==2{
            j=j+1
            vul2:=" --Nums "+PWDList[2]
            PWD[j]=vul2
        }
    } // for i:= ...

    _=genmai.PythonParser(PWD)
    fmt.Println("弱密码已生成")

    return
}

///////////////////////////////
//SSH爆破
func
genmaiSSHBurst(SSHBurst string,SSHBurstList []string) {
    if SSHBurstList[0]!="false"{
        SSHHostCheck,list := genmai.SecCheckIP(SSHBurstList[0])
        if SSHHostCheck!="true"{
            fmt.Println("SSH模块 host格式报错",list)
            log.Println("SSH模块 host格式报错")
        }else{
            poolNums,err:= strconv.Atoi(SSHBurstList[1])
            if err!=nil{
                fmt.Println(err)
                log.Println(err)
            }else{
                SSHExplosion.SshExp(list[:],poolNums)
            }
        }
    }else{
        fmt.Println("SSH爆破模块,参数使用错误,请添加host参数")
        log.Println("SSH爆破模块,参数使用错误,请添加host参数")
    } // if SSHBurstList ... else ...

    return
}


///////////////////////////////
//Nmap模块解析
func
genmaiNmapScan(Nmap string, NmapScanList []string) {
    Map:=make(map[int]string)
    Map[0]="Nmap/nmapScan"

    if NmapScanList[0]!="false"{
        if NmapScanList[1]=="all"{
            Map[1]=" -H "+NmapScanList[0]+" -p "+"0-65000"
            _=genmai.PythonParser(Map)

    }else{

        Map[1]=" -H "+NmapScanList[0]+" -p "+NmapScanList[1]
        _=genmai.PythonParser(Map)
    }
    fmt.Println("Nmap模块结束...")
    }else{
        fmt.Println("Nmap模块,参数使用错误,请添加host参数")
        log.Println("Nmap模块,参数使用错误,请添加host参数")
    }

    return
}

///////////////////////////////


// Fofa模块解析
func
genmaiFofaApi(Fofa string,fofaCom string) {
    Map:=make(map[int]string)
    Map[0]="Fofa/FofaApi"

    if fofaCom!="null"{
        Map[1]=" -c "+fofaCom
        _=genmai.PythonParser(Map)
    }else{
        fmt.Println("Fofa模块,参数使用错误,请添加fofaCom参数")
        log.Println("Fofa模块,参数使用错误,请添加fofaCom参数")
    }
    fmt.Println("Fofa模块结束...")

    return
}

///////////////////////////////
// 快扫模块
func
genmaiSystemFastScan(scan string,args Args) {
    jout:=args.OutPutJson
    Docx:=args.Docx
    Pdf:=args.Pdf
    createfile_fun := func (m map[string]interface{}, fileName string){
        path:="../data/Report/"+"FastScan_"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
        file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
        if err != nil {
            fmt.Println("open file failed,err:",err)
            return
        }

        defer file.Close()
        jsonVul, err := json.MarshalIndent(m, "", "     ")
        if err != nil {
            fmt.Println("json err ", err)
        }
        file.Write([]byte(jsonVul))    //写入字节切片数据
    }
    // resultMap:=FastScan.GetdpkgInfo()
    resultMap,resultMapNotIn:=genmai.DoctorIns().GenmaiFastScan()
    if len(resultMap)==0{
        fmt.Println("FastScan info: No vulnerability")
        if jout !="null"{
            createfile_fun(resultMap,jout)
        }
        if Docx !="null"{
            FastScanResult=resultMap
            FastScanNotInResult=resultMapNotIn
        }
        if Pdf !="null"{
            FastScanResult=resultMap
            FastScanNotInResult=resultMapNotIn
        }
    }else{
        if jout !="null"{
            createfile_fun(resultMap,jout)
        }
        if Docx !="null"{
            FastScanResult=resultMap
            FastScanNotInResult=resultMapNotIn
        }
        if Pdf !="null"{
            FastScanResult=resultMap
            FastScanNotInResult=resultMapNotIn
        }
    }

    fmt.Println("[*] Info:版本匹配检测结束...")

    return
}

func
genmaiSystemIso(scan string,args Args) {
    jout:=args.OutPutJson
    Docx:=args.Docx
    Pdf:=args.Pdf
    createfile_fun := func (m map[string]interface{}, fileName string){
        path:="../data/Report/"+"Iso"+fileName+".json"
        Bool ,err:=genmai.PathExists(path)
        if err != nil {
            fmt.Println(err)
            return
        }
        if Bool==true {
            err := os.Remove(path)
            if err != nil {
                log.Println("File overwritten successfully")
            } else {
                log.Println("File overwrite failed")
            }
        }
        file, err := os.OpenFile(path, os.O_WRONLY|os.O_CREATE|os.O_APPEND, 0666)
        if err != nil {
            fmt.Println("open file failed,err:",err)
            return
        }

        defer file.Close()
        jsonVul, err := json.MarshalIndent(m, "", "     ")
        if err != nil {
            fmt.Println("json err ", err)
        }
        file.Write([]byte(jsonVul))    //写入字节切片数据
    }
    
    re:=Kybuilder.GenmaiIsoScan(args.IsoScan)
    var sep string = " "
    dpkgInfo := strings.Split(re, sep)
    PROJECT_CODENAME:=genmai.GetdOpInfo()
    framwork:=genmai.GetdOpUInfo("uname -m")
    resultMap,resultMapNotIn:=FastScan.MakeFastScan(dpkgInfo , PROJECT_CODENAME ,framwork)
    if len(resultMap)==0{
        fmt.Println("ISO info: No vulnerability")
        if jout !="null"{
            createfile_fun(resultMap,jout)
        }
        if Docx !="null"{
            IsoResult=resultMap
            IsoNotInResult=resultMapNotIn
        }
        if Pdf !="null"{
            IsoResult=resultMap
            IsoNotInResult=resultMapNotIn
        }
    }else{
        if jout !="null"{
            createfile_fun(resultMap,jout)
        }
        if Docx !="null"{
            IsoResult=resultMap
            IsoNotInResult=resultMapNotIn
        }
        if Pdf !="null"{
            IsoResult=resultMap
            IsoNotInResult=resultMapNotIn
        }
    }

    fmt.Println("ISO检测结束...")
}
func Update(){
    currentDir, err:= os.Getwd()
    if err != nil {
        panic(err)
    } else {
    }
    currentDir=currentDir+"/../"
    os.Chdir(currentDir)

    currentDir, err = os.Getwd()
    if err != nil {
        panic(err)
    } else {
        cmd := exec.Command("git","pull")
        var stdout, stderr bytes.Buffer
        cmd.Stdout = &stdout // 标准输出
        cmd.Stderr = &stderr // 标准错误
        err := cmd.Run()
        outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
        if len(errStr)!=0{
            fmt.Printf(errStr)
        }
        outStr=strings.TrimSpace(outStr)
        if err != nil {
            fmt.Println("Updte Err:", err)
        }
        fmt.Println(outStr)
    }

}
// genmai plug-in modules
////////////////////////////////////////////////////////////////


//////////////////////////////环境配置////////////////////////////
// aux functions
func untarSandboxViPyEnv (){
    _,arch:=genmai.GetCurrentFw()
    filename := "../data/SandboxViPyEnv/myenv_"+arch+".tar.xz"
    // filename := "./test.tar.xz"
    targetDir := "../data/SandboxViPyEnv/"+arch

    // return
    // 确保目标目录存在
    if _, err := os.Stat(targetDir); os.IsNotExist(err) {
        if err := os.MkdirAll(targetDir, 0755); err != nil {
            panic(err)
        }
    }

    // 打开 .tar.xz 文件
    xzFile, err := os.Open(filename)
    if err != nil {
        panic(err)
    }
    defer xzFile.Close()


    // 创建 XZ 读取器
    xzReader, err := xz.NewReader(xzFile)
    if err != nil {
        panic(err)
    }

    // 创建 Tar 读取器
    tarReader := tar.NewReader(xzReader)

    // TODO: 进度条：暂时无法实现：获取不了解压后的文件大小
    // fileSize := int64(100*1024*1024)
    // fmt.Print(">>", fileSize)
    // // 创建进度条
    // bar := pb.Full.Start64(fileSize)
    // bar.Set(pb.Bytes, true)

    // 逐个解压缩文件
    for {
        header, err := tarReader.Next()
        if err == io.EOF {
            // 已经解压缩完所有文件
            break
        }
        if err != nil {
            panic(err)
        }

        // 获取目标文件路径
        destPath := filepath.Join(targetDir, header.Name)

        // 如果是目录，则创建目录
        if header.Typeflag == tar.TypeDir {
            err = os.MkdirAll(destPath, 0755)
            if err != nil {
                panic(err)
            }
            continue
        }

        // 如果是符号链接，则创建符号链接
        if header.Typeflag == tar.TypeSymlink {
            linkDest := header.Linkname
            if !filepath.IsAbs(linkDest) {
                linkDest = filepath.Join(filepath.Dir(destPath), linkDest)
            }
            err = os.Symlink(linkDest, destPath)
            if err != nil {
                panic(err)
            }
            continue
        }

        // 如果是设备文件，则创建设备文件
        if header.FileInfo().Mode()&os.ModeDevice != 0 {
            var deviceFile *os.File
            if header.FileInfo().Mode()&os.ModeCharDevice != 0 {
                deviceFile, err = os.OpenFile(destPath, os.O_WRONLY, 0666)
            } else {
                deviceFile, err = os.OpenFile(destPath, os.O_WRONLY|os.O_CREATE, 0666)
            }
            if err != nil {
                panic(err)
            }
            defer deviceFile.Close()
            err = deviceFile.Chown(int(header.Uid), int(header.Gid))
            if err != nil {
                panic(err)
            }
            err = deviceFile.Chmod(header.FileInfo().Mode())
            if err != nil {
                panic(err)
            }
            continue
        }

        // 创建目标文件
        destFile, err := os.Create(destPath)
        if err != nil {
            panic(err)
        }
        defer destFile.Close()

        // 将 Tar 文件内容复制到目标文件和进度条中
        _, err = io.Copy(destFile, tarReader)
        if err != nil {
            panic(err)
        }
        // TODO: 进度条：暂时无法实现：获取不了解压后的文件大小
        // bar.Add64(n)
        // os.Stdout.Sync()

        // 根据 Tar 文件头中的权限设置目标文件的权限
        err = os.Chmod(destPath, header.FileInfo().Mode())
        if err != nil {
            panic(err)
        }

        // 需要显式关闭文件句柄
        destFile.Close()
    }
        
    // TODO: 进度条：暂时无法实现：获取不了解压后的文件大小
    // // 关闭进度条
    // bar.SetCurrent(fileSize)
    // bar.Finish()

    // // 关闭 XZ 读取器
    // err = xzReader.Close()
    // if err != nil {
    //     panic(err)
    // }

    // 解压缩完成
}
// aux functions

// root配置
func SetEnv(command string){
    cmd := exec.Command("bash","-c",command)
    var stdout, stderr bytes.Buffer
    cmd.Stdout = &stdout // 标准输出
    cmd.Stderr = &stderr // 标准错误
    err := cmd.Run()
    outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
    if len(errStr)!=0{
        fmt.Printf(errStr)
    }
    outStr=strings.TrimSpace(outStr)
    if err != nil {
        fmt.Println("Updte Err:", err)
    }
    fmt.Println(outStr)
}

// 检测 root 用户是否已启用
func isRootEnabled(password string) int {
    password = strings.ReplaceAll(password," ","")
    // 需要除去空格
    command:="echo "+password+" | sudo -S cat /etc/shadow"
    cmd := exec.Command("bash", "-c", command)
    output, err := cmd.Output()
    if err != nil {
        fmt.Println(err)
        return 0
    }

    scanner := bufio.NewScanner(strings.NewReader(string(output)))
    for scanner.Scan() {
        fields := strings.Split(scanner.Text(), ":")
        if fields[0] == "root" && fields[1] == "!" {
            return 1
        }
    }
    if err := scanner.Err(); err != nil {
        fmt.Println(err)
    }

    return 2
}

// 创建 root 密码
func createRootPassword(password string) {
    fmt.Println("[*] Creating root password...")
    backupFile("/etc/shadow",password)

    cmd := exec.Command("sudo", "passwd", "root")
    cmd.Stdin = bytes.NewBufferString(password + "\n" + password + "\n" + password + "\n")
    err := cmd.Run()
    if err != nil {
        fmt.Println(err)
        return
    }
}

// 修改 sshd 配置文件，允许 root 用户登陆
func modifySshdConfig(password string) {
    fmt.Println("[*] Modifying sshd configuration file...")

    // 备份原有配置文件
    backupFile("/etc/ssh/sshd_config",password)

    // 修改配置文件
    // 执行 sed 命令，将 PermitRootLogin 字段修改为 yes
    cmd := exec.Command("sudo","sed", "-i", "-e", "s/^\\(#\\s*\\)\\?PermitRootLogin\\s*\\(yes\\|no\\)/PermitRootLogin yes/", "/etc/ssh/sshd_config")
    cmd.Stdin = bytes.NewBufferString(password + "\n")
    if err := cmd.Run(); err != nil {
        fmt.Println(err)
        return
    }
    fmt.Println("[*] PermitRootLogin 已修改为 yes")
}

// 重启 sshd 服务
func restartSshdService(password string) {
    fmt.Println("[*] Restarting sshd service...")

    cmd := exec.Command("sudo", "systemctl", "restart", "ssh")
    cmd.Stdin = bytes.NewBufferString(password + "\n")
    err := cmd.Run()
    if err != nil {
        fmt.Println(1,err)
        return
    }
}

// 恢复 sshd 配置文件
func restoreSshdConfig(password string) {
    fmt.Println("[*] Restoring sshd configuration file...")

    // 恢复原有配置文件
    restoreFile("/etc/ssh/sshd_config",password)
    // 恢复服务状态
    restartSshdService(password)
}

// 恢复 root 状态
func deleteRootPassword(password string) {
    fmt.Println("[*] Restoring root password...")

    restoreFile("/etc/shadow",password)
}


// 备份文件
func backupFile(path string,password string) {
    cmd := exec.Command("sudo", "cp", path, path+".bak")
    cmd.Stdin = bytes.NewBufferString(password + "\n")
    err := cmd.Run()
    if err != nil {
        fmt.Println(err)
        return
    }
}

// 恢复文件
func restoreFile(path string,password string) {
    cmd := exec.Command("sudo", "cp", path+".bak", path)
    cmd.Stdin = bytes.NewBufferString(password + "\n")
    err := cmd.Run()
    if err != nil {
        fmt.Println(err)
        return
    }

    cmd = exec.Command("sudo", "rm", path+".bak")
    err = cmd.Run()
    if err != nil {
        fmt.Println(err)
        return
    }
}

