package FastScan

import(
	"gopkg.in/yaml.v2"
    "io/ioutil"
	"runtime"
	"os/exec"
	"strings"
	"bytes"
	"log"
	"fmt"
)

type Config struct {
	Name    string `yaml:"name"`
	Version string `yaml:"version"`
	Database struct {
		Dbhostsip     string `yaml:"dbhostsip"`
		Username string `yaml:"username"`
		Password string `yaml:"password"`
        Dbname string `yaml:"dbname"`
	} `yaml:"database"`
}

type FalseAlarmPackages struct{
	Packages []Packages `yaml:"Packages"`
}
type Packages struct{
	PackageInfo 	map[string]string `yaml:"PackageInfo"`
}

// 获取当前系统架构
func GetCurrentFw()(string,string){
    system:=runtime.GOOS
    arch:=runtime.GOARCH
    system = strings.TrimSpace(system)
    arch = strings.TrimSpace(arch)
    return system,arch
}
func GetdOpInfo()string{
	command:="cat /etc/os-release | awk 'NR==14{print $1}'"   
	cmd := exec.Command("bash","-c",command)
	var stdout, stderr bytes.Buffer
	cmd.Stdout = &stdout // 标准输出
	cmd.Stderr = &stderr // 标准错误
	err := cmd.Run()
	outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
	if len(errStr)!=0{
		fmt.Println(errStr)
	}
	outStr = strings.TrimSpace(outStr)
	if len(outStr) > 1 && outStr[len(outStr)-1] == '"'{
		outStr = outStr[:len(outStr)-1]
	}
	if err != nil {
		log.Println("cmd.Run() failed with %s\n", errStr)
	}
    return outStr
}
func GetdOpUInfo()string{ 
	cmd := exec.Command("uname","-m")
	var stdout, stderr bytes.Buffer
	cmd.Stdout = &stdout // 标准输出
	cmd.Stderr = &stderr // 标准错误
	err := cmd.Run()
	outStr, errStr := string(stdout.Bytes()), string(stderr.Bytes())
	if len(errStr)!=0{
		fmt.Println(errStr)
	}
	outStr = strings.TrimSpace(outStr)
	if err != nil {
		log.Println("cmd.Run() failed with %s\n", errStr)
	}
    return outStr
}
// 获取源码包信息
func getSourceCode(packageName string)string{
	str:="dpkg -s "+packageName+" |grep Source |awk '{print $2}'"
	cmd := exec.Command("bash","-c",str)
	var stdout bytes.Buffer
	cmd.Stdout = &stdout // 标准输出
	_ = cmd.Run()
	outStr := string(stdout.Bytes())
	outStr = strings.TrimSpace(outStr)
    return outStr
}
func ConfigYamlParse()(string,string,string,string){
    data, err := ioutil.ReadFile("config.yaml")
	if err != nil {
		log.Println(err)
	}

	// 解析 YAML 数据
	var config Config
	err = yaml.Unmarshal(data, &config)
	if err != nil {
		log.Println(err)
	}

	return config.Database.Username,config.Database.Password,config.Database.Dbhostsip,config.Database.Dbname
}
func FastScanFalseAlarmConfigYamlParse(dpkgName string)bool{
    data, err := ioutil.ReadFile("FastScanFalseAlarmConfig.yaml")
	if err != nil {
		log.Println(err)
	}


	// 解析 YAML 数据
	var config FalseAlarmPackages
	err = yaml.Unmarshal(data, &config)
	if err != nil {
		log.Println(err)
	}
	for _,Info:=range config.Packages {
		if Info.PackageInfo["Name"] == dpkgName && Info.PackageInfo["Status"] == "discard"{
			return true
		}
		// for key,value := range Info.PackageInfo{
		// 	if key == "Name" || key == "Status"{
		// 		InfoVuls = append(InfoVuls,value)
		// 	}
		// }
	}
	return false

}