import requests
import argparse
TIMEOUT = 30


# 获取某个distro id镜像的所有包列表接口
def get_packages_list_distro(distroid):
    if distroid is None:
        return False
    url = 'http://distro.kylin.com/web_pungi/api/distro/' + distroid + '/packages'

    while True:
        try:
            response = requests.get(url=url,timeout=TIMEOUT)
            break
        except (KeyboardInterrupt, SystemExit):
            raise
            break
        except Exception as e:
            print(e)
            print('HAVE A ERROR! RETRY IT!')
            continue
    deb_info_list = response.json()
    return deb_info_list


# 获取某个kybuilder id镜像的所有包列表接口
def get_packages_list_kybuilder(kybuilderid):
    if kybuilderid is None:
        return False
    url = "http://builder.kylin.com/kybuilder/build/package_list/" + kybuilderid
    headers = {
        "User-Agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.82 Safari/537.36",
        "Access-Email": "zhouyang@kylinos.cn",
        "Access-Token": "VoJrnDiO03LpcQKRs6zqdGCHjZ7alXB2"
    }
    response = requests.get(url=url, verify="./kybuilder平台证书", headers=headers)
    deb_info_list = response.json()
    return deb_info_list

'''
使用方法
传入的字段均需为字符串形式
platform：'kybuilder'、'distro'
id:平台iso id
'''
def get_packages_list(platform, id):
    packages_list = []
    liststring = []
    if platform == 'distro':
        packages_list = get_packages_list_distro(id)
    elif platform == 'kybuilder':
        packages_list = get_packages_list_kybuilder(id)
    vul = ""
    for i in range(len(packages_list)):
        liststring.append(packages_list[i]['source'][0]+" "+packages_list[i]['source'][1])
    liststring = list(set(liststring))
    for i in range(len(liststring)):
        vul = vul+liststring[i]+" "
    # return liststring
    print(vul)

if __name__ == '__main__':
    # 1. 定义命令行解析器对象
    parser = argparse.ArgumentParser(description='iso')
    
    # 2. 添加命令行参数
    parser.add_argument('-kybuilder')

    # 3. 从命令行中结构化解析参数
    args = parser.parse_args()
    kybuilder = args.kybuilder
    get_packages_list('kybuilder',kybuilder)
